#!/usr/bin/python
##################### Import needed libraries ###############################
import pandas
import scipy
import scipy.signal
import numpy
import matplotlib
from matplotlib import rc
rc('font',**{'family':'sans-serif','sans-serif':['Helvetica']})
## for Palatino and other serif fonts use:
rc('font',**{'family':'serif','serif':['Palatino']})
rc('text', usetex=True)
import pickle
from matplotlib import pyplot as plt
from matplotlib import pylab as pyl
import statsmodels.tsa.vector_ar.var_model as vm
import statsmodels.tsa.filters.hp_filter as hpf
from scipy.io.matlab import savemat, loadmat
import os
import  sys
import copy
import string
import datetime as dt
from fred import Fred
import glob
import pp
fred_key = 'c5c6ec1dd5e1eb81b2727053690986db'
fred_key2 = '5d3a1dcaeb1545e07b9f24fa787625f2'
##############################################################################
##############################################################################

# Allow number of bootstraps and do_idio_boot to be passed in at the command line
print sys.argv
if len(sys.argv) > 1:
    bdraw = int(sys.argv[1])
if len(sys.argv) > 2 and int(sys.argv[2]) == 1:
    do_plots = True
elif len(sys.argv) > 2 and int(sys.argv[2]) == 0:
    do_plots = False
if len(sys.argv) > 3 and int(sys.argv[3]) == 1:
    do_idio_boot = True
elif len(sys.argv) > 3 and int(sys.argv[3]) == 0:
    do_idio_boot = False
if len(sys.argv) > 4 and int(sys.argv[4]) == 1:
    do_series_plots = True
elif len(sys.argv) > 4 and int(sys.argv[4]) == 0:
    do_series_plots = False
if len(sys.argv) > 5 and sys.argv[5] == 'APPEND':
    append = True


def chain_dot(*arrs):
    """
Returns the dot product of the given matrices.

Parameters
----------
arrs: argument list of ndarray

Returns
-------
Dot product of all arguments.

Example
-------
>>> import numpy as np
>>> from statsmodels.tools import chain_dot
>>> A = np.arange(1,13).reshape(3,4)
>>> B = np.arange(3,15).reshape(4,3)
>>> C = np.arange(5,8).reshape(3,1)
>>> chain_dot(A,B,C)
array([[1820],
[4300],
[6780]])
"""
    return reduce(lambda x, y: numpy.dot(y, x), arrs[::-1])

    

# In total there are three US recessions in the sample considered here
rdates = []
rdates.append([dt.datetime(1990,7,1),dt.datetime(1991,3,1)])
rdates.append([dt.datetime(2001,3,1),dt.datetime(2001,11,1)])
rdates.append([dt.datetime(2007,12,1),dt.datetime(2009,7,1)])

modconfig = {}
# This model's name or title, used for pickling results
modname = 'BLOOM_favar_model2'
modconfig['modname'] = modname


# Get the data from the directory, later we will add the St. Louis Fed
datafile = 'October_Updated_finaldata.csv'
modconfig['datafile'] = datafile
datapath = '../data/'
modconfig['datapath'] = datapath
data = pandas.read_csv(os.path.join(datapath,datafile),delimiter="\t")
data = pandas.DataFrame(numpy.array([data['uncert'].values,data['spindex'].values,data['ffr'].values,
                                     data['employment'].values,data['ip'].values,
                                     data['copper'].values]).T,
                        columns=['UNCERT','SPINDEX','FFR','EMP','IP','COPPER'])

bloomli = ['UNCERT','SPINDEX','FFR','EMP','IP','COPPER']

datadic = {}
datadic.update({'UNCERT':numpy.array(data['UNCERT'].values)})
datadic.update({'SPINDEX':numpy.array(data['SPINDEX'].values)})
#datadic.update({'FFR':numpy.array(data['FFR'].values)})
datadic.update({'EMP':numpy.array(data['EMP'].values)})
#datadic.update({'IP':numpy.array(data['IP'].values)})
datadic.update({'COPPER':numpy.array(data['COPPER'].values)})




# Function to transform the raw data according to some classification
# 1 = levels
# 2 = first seasonal difference
# 3 = second seasonal difference
# 4 = log level
# 5 = log first seasonal difference
# 6 = log second seasonal difference
# 7 = detrend log using hp filter monthly data
# 8 = detrend log using hp filter quarterly data
# 16 = log second seasonal difference
# 17 = (1-L)(1-L^12)
# 18 = log of (1-L)*annualizing factor (i.e. x4 for quarterly and x12 for monthly
# 19 = filter the level using simple time-trend
# 20 = filter the log using simple time-trend
# 21 = filter the level using quadratic time-trend
# 22 = filter the log using quadratic time-trend
# 23 = filter the level using cubuc time-trend
# 24 = filter the log using cubic time-trend
vardic = {}
vardic.update({'UNCERT':22}) # Was 1
vardic.update({'SPINDEX':7}) # Was 24
vardic.update({'FEDFUNDS':19})
vardic.update({'INTDSRUSM193N':19})
vardic.update({'INTGSBUSM193N':19})
#vardic.update({'CD1M':19})
vardic.update({'EMP':7})
vardic.update({'USGOOD':7})
vardic.update({'AWHI':7})
#vardic.update({'W209RC1':7})
#vardic.update({'CES3000000008':7})
vardic.update({'CFNAIMA3':1})
vardic.update({'PAYEMS':7})
vardic.update({'USTRADE':7})
#vardic.update({'TWEXMPA':4})
#vardic.update({'AWOTMAN':4})
vardic.update({'INDPRO':7})
vardic.update({'MYAGM2USM052N':7})
#vardic.update({'RPI':7})
vardic.update({'DPCERA3M086SBEA':7})
vardic.update({'USCONS':7})
vardic.update({'CES2023610001':7})
vardic.update({'M12MTVUSM227NFWA':7})
vardic.update({'NOM1M2':7})
vardic.update({'M2MSL':7})
vardic.update({'IPMAN':7})
vardic.update({'IPDMAN':7})
#vardic.update({'ALTSALES':4})
#vardic.update({'TOTALSA':4})
vardic.update({'MSACSR':4})
#vardic.update({'COMPHAI':7})
vardic.update({'SAVINGSL':7})
vardic.update({'A576RC1':7})
vardic.update({'MICH':1})
vardic.update({'AHETPI':7})
vardic.update({'PI':7})
vardic.update({'W875RX1':7})
vardic.update({'BUSLOANS':7})
vardic.update({'LOANINV':7})
vardic.update({'REALLN':7})
vardic.update({'LOANS':7})
#vardic.update({'NONREVSL':7})
#vardic.update({'USGSEC':7})
#vardic.update({'CURRCIR':7})
#ardic.update({'PSAVERT':7})
#vardic.update({'DSPIC96':7})
vardic.update({'COPPER':22}) # Was 1
vardic.update({'OILPRICE':22}) # Was 1
vardic.update({'GS2':19})
#vardic.update({'CLF16OV':7})
vardic.update({'GS10':19})
vardic.update({'MSLB20':19})
vardic.update({'PPIFGS':7})
vardic.update({'CPIAUCSL':7})
vardic.update({'CPILFESL':7})
vardic.update({'CPIFABSL':7})
vardic.update({'CPIENGSL':7})
vardic.update({'PPICRM':7})
vardic.update({'CPIHOSSL':7})
vardic.update({'M2SL':7})
vardic.update({'M2':7})
vardic.update({'UNRATE':1})
vardic.update({'CAUR':1})
vardic.update({'FLUR':1})
vardic.update({'UEMPMEAN':1})
vardic.update({'LNS12032195':1})
#vardic.update({'LNS14000012':1})
#vardic.update({'AWHMAN':4})
vardic.update({'CFNAI':1})
vardic.update({'IPDCONGD':7})
vardic.update({'TCU':22})
vardic.update({'MCUMFN':22})
vardic.update({'HOUST':7}) # Was 1
#vardic.update({'HNFSEPUSSA':4})
vardic.update({'PERMIT':7})
#vardic.update({'UNDCONTSA':4})
#vardic.update({'USSTHPI':7})
vardic.update({'HSN1F':7})
vardic.update({'NAPM':1})
vardic.update({'USSLIND':1})
vardic.update({'IC4WSA':1})
vardic.update({'MZM':7})
vardic.update({'TB3MS':19})
vardic.update({'TB6MS':19})
vardic.update({'GS1':19})
vardic.update({'GS5':19})
vardic.update({'UMCSENT':1})
vardic.update({'AAA':19})
vardic.update({'BAA':19})
vardic.update({'EMRATIO':7})
#vardic.update({'A229RC0':7})
#vardic.update({'MORTG':19})
vardic.update({'PCE':7})
vardic.update({'GPDI':7})
vardic.update({'NAPMII':1})
vardic.update({'NAPMNOI':1})
vardic.update({'NAPMEI':1})
vardic.update({'NAPMSDI':1})
vardic.update({'NAPMPRI':1})
vardic.update({'NAPMPI':1})
vardic.update({'CPIUFDNS':7})
vardic.update({'CUSR0000SAC':7})
vardic.update({'CUSR0000SETB01':7})
vardic.update({'CWSR0000SA0':7})
vardic.update({'PPIITM':7})
vardic.update({'GS7':19})
vardic.update({'GS3':19})
vardic.update({'PCEPI':7})
vardic.update({'PCEPILFE':7})
vardic.update({'PCEDG':7})
vardic.update({'PCEND':7})
vardic.update({'PCES':7})
#vardic.update({'TWEXMMTH':1})
vardic.update({'MZMV':22})
vardic.update({'M2V':22})
vardic.update({'M1V':7})

groupdic = {}
groupdic['LEAD'] = ['UMCSENT','USSLIND','NAPMII','NAPMNOI','NAPMEI','NAPMSDI','NAPMPRI','NAPMPI']
groupdic['EMP'] = ['EMP','PAYEMS','EMRATIO','LNS12032195','IC4WSA','UEMPMEAN','UNRATE','CAUR','FLUR','USGOOD','USCONS']
groupdic['OUT'] = ['IPMAN','IPDMAN','INDPRO','IPDCONGD','GPDI']
groupdic['TS'] = ['GS1','GS2','GS3','GS5','GS7','GS10']
groupdic['MONR'] = ['FEDFUNDS','TB3MS','TB6MS','BAA']
groupdic['MONEY'] = ['M1V','M2V','M2SL','MZM','M2','NOM1M2']
groupdic['COM'] = ['OILPRICE','COPPER']
groupdic['CPI'] = ['CPIHOSSL','CPIENGSL','CPIUFDNS','CPIAUCSL','CPILFESL','CPIFABSL','CUSR0000SAC','CUSR0000SETB01']
groupdic['PPI'] = ['PPIFGS','PPIITM','PPICRM']
groupdic['CONS'] = ['PCEPI','PCEPILFE','PCEDG','PCEND','PCES']
groupdic['INC'] = ['PI','W875RX1']
groupdic['HOUSE'] = ['HOUST','PERMIT','HSN1F','MSACSR']
groupdic['MISC'] = ['UNCERT','SPINDEX']



# Method used to clean all directories of their contents    
def clean_dirs(modpath=None,modname=None):
    base_path = '../graphs/'+modname
    seriesxx = glob.glob(base_path+'/xdata_irfs/*')
    for f in seriesxx:
        os.remove(f)
    seriesff = glob.glob(base_path+'/factor_irfs/*')
    for f in seriesff:
        os.remove(f)
    seriesf = glob.glob(base_path+'/shock_irfs/*')
    for f in seriesf:
        os.remove(f)
    seriess = glob.glob(base_path+'/series/*')
    for f in seriess:
        os.remove(f)
    seriesfit = glob.glob(base_path+'/fitted/*')
    for f in seriesfit:
        try: os.remove(f)
        except: pass
    seriesmat = glob.glob(base_path+'/fitted/bsample/*')
    for f in seriesmat:
        os.remove(f)
    seriesfac = glob.glob(base_path+'/factors/*')
    for f in seriesfac:
        try: os.remove(f)
        except: pass
    seriesmat = glob.glob(base_path+'/factors/bsample/*')
    for f in seriesmat:
        os.remove(f)
    seriesmat = glob.glob(base_path+'/matrices/*')
    for f in seriesmat:
        os.remove(f)
    seriesmat = glob.glob(base_path+'/idio_shocks/*')
    for f in seriesmat:
        try: os.remove(f)
        except: pass
    seriesmat = glob.glob(base_path+'/fevds/*')
    for f in seriesmat:
        os.remove(f)
    seriesmat = glob.glob(base_path+'/idio_shocks/bsample/*')
    for f in seriesmat:
        os.remove(f)
    seriesmat = glob.glob(base_path+'/irfs/*')
    for f in seriesmat:
        try: os.remove(f)
        except: pass
    seriesmat = glob.glob(base_path+'/irfs/shock_1/*')
    for f in seriesmat:
        os.remove(f)   
    seriesmat = glob.glob(base_path+'/irfs/shock_2/*')
    for f in seriesmat:
        os.remove(f)
    seriesmat = glob.glob(base_path+'/irfs/shock_3/*')
    for f in seriesmat:
        os.remove(f)
    seriesmat = glob.glob(base_path+'/irfs/shock_4/*')
    for f in seriesmat:
        os.remove(f)
    seriesmat = glob.glob(base_path+'/irfs/sshock_1/*')
    for f in seriesmat:
        os.remove(f)   
    seriesmat = glob.glob(base_path+'/irfs/sshock_2/*')
    for f in seriesmat:
        os.remove(f)
    seriesmat = glob.glob(base_path+'/irfs/sshock_3/*')
    for f in seriesmat:
        os.remove(f)
    seriesmat = glob.glob(base_path+'/irfs/sshock_4/*')
    for f in seriesmat:
        os.remove(f)
    seriesmat = glob.glob(base_path+'/irfs/pshock_1/*')
    for f in seriesmat:
        os.remove(f)   
    seriesmat = glob.glob(base_path+'/irfs/pshock_2/*')
    for f in seriesmat:
        os.remove(f)
    seriesmat = glob.glob(base_path+'/irfs/pshock_3/*')
    for f in seriesmat:
        os.remove(f)
    seriesmat = glob.glob(base_path+'/irfs/pshock_4/*')
    for f in seriesmat:
        os.remove(f)
    seriesmat = glob.glob(base_path+'/irfs/ashock_1/*')
    for f in seriesmat:
        os.remove(f)   
    seriesmat = glob.glob(base_path+'/irfs/ashock_2/*')
    for f in seriesmat:
        os.remove(f)
    seriesmat = glob.glob(base_path+'/irfs/ashock_3/*')
    for f in seriesmat:
        os.remove(f)
    seriesmat = glob.glob(base_path+'/irfs/ashock_4/*')
    for f in seriesmat:
        os.remove(f)
    seriesmat = glob.glob(base_path+'/irfs/aashock_1/*')
    for f in seriesmat:
        os.remove(f)   
    seriesmat = glob.glob(base_path+'/irfs/aashock_2/*')
    for f in seriesmat:
        os.remove(f)
    seriesmat = glob.glob(base_path+'/irfs/aashock_3/*')
    for f in seriesmat:
        os.remove(f)
    seriesmat = glob.glob(base_path+'/irfs/aashock_4/*')
    for f in seriesmat:
        os.remove(f)

# Use data and table already saved to disk?
data_download = True
modconfig['data_download'] = data_download
# Define frequency of data
freq = 'M'
modconfig['freq'] = freq
# Maximum upper bound of factors to extract
rr_max = 12
# Preferred dynamic factors
qq_max = 4
# How much memory of past shocks to keep for factor and common component infinite MA bootstraps
memory_adj = 400
# How much memory of past shocks to keep for factor and idiosyncratic component infinite MA bootstraps
memory_adj2 = 200
# Should the common component bootstraps be carried out using Monte Carlo simulation?
do_mcbs_comp = True
# Should the idiosyncratic error bootstraps be carried out using Monte Carlo simulation?
do_mcbs_idio = True
# Do the factor model bootstrap or load data from disk
do_fac_boot = True
# Do the factor model bootstrap or load data from disk
if 'do_idio_boot' not in dir(): do_idio_boot = False
# Check also the sign of the coefficients of the estimates?
check_betta = False
# Check also the sign of the reduced variance-covariance matrix of boostrap estimates?
check_redcovmat = False
# Check also magnitude of boostrap estimates besides sign?
check_magnitude = False
# Upper boundary for magnitude in percentages
upperb = 160.0
# Lower boundary for magnitude in percentages
lowerb = 70.0
# Increment of Rotation Matrix parameter
rotinc = 0.2
# Number of dimensios for regression check of bootstraps
regcheck_dim = 3
# Use MA or AR for common components bootstraps?
use_comp_ma = False
# Use MA or AR for idiosyncratic errors bootstraps?
use_idio_ma = False
# Should the IRFs be sign-filtered at bootstrap stage?
use_sign_filter = False
# Bootstrap data blocks-to-bdraw ratio
bblock_ratio = 1
# Offset for mderiv matrix
offset1 = 6
# Offset for mderiv matrix
offset2 = 6
# The slope criterion
slope_crit = 0.70
# IRF regression R2 criterion in percentages
R2_crit = 30.0
# R2 crit IRF period index
R2ind_crit = -1
# Use the Cholesky HH matrix?
use_cholesky = True

#Define the sign restriction matrix
NAN = numpy.NaN


#Sign restriction matrix, use 99 for no restriction imposed
                     #Tech   Dem  Supp  Unc
restrim = numpy.array([[1, 99, 1, 1],\
                       [99, 1, 99, -1],\
                       [99, 99, 1, -1],\
                       [99, -1, -1, 1]])

# Should bootstrap run be appended?
if 'append' not in dir(): append = False

###################################################################################################################
######################## Define here the lags for the data and the factors ########################################
### There is a trade-off here, you can chose not to use any lags on the data itself and let the factors capture ###
### all of the data's persistence, in that case your lag structure on the factors needs to be long enough #########
# Should the original data be filtered using their own lags?
xdata_filter = False
modconfig['xdata_filter'] = xdata_filter
# Define the number of lags in the VAR, only applicable if option above was chosen to be true
nlags = 6
modconfig['nlags'] = nlags
# Define the number of lags in the VAR of the factors, we always keep this at 1, becaus we are using a companion structure
flags = 6
modconfig['flags'] = flags
# Define the number of common static factors to be employed, but this can later be overriden by automatic selection
sfacs = 12
modconfig['sfacs'] = sfacs
###################################################################################################################
###################################################################################################################
# Define the convergence criterion in PERCENTAGES
conv_crit = 0.001
modconfig['conv_crit'] = conv_crit
# Should any graphs be plotted and saved?
if 'do_plots' not in dir(): do_plots = True
modconfig['do_plots'] = do_plots
# Should series graphs be plotted and saved?
if 'do_series_plots' not in dir(): do_series_plots = True
modconfig['do_series_plots'] = do_series_plots
# Should IRFs and confidence intervals be computed?
do_irfs = True
modconfig['do_irfs'] = do_irfs
# Should all directories be deleted before a model run?
predel = True
modconfig['predel'] = predel
# How many periods for IRFs ?
irfp = 48
modconfig['irfp'] = irfp
# Calculate variance decomposition?
do_vdc = True
modconfig['do_vdc'] = do_vdc
# How many periods forecast for variance decomposition ?
vdcp = 60
modconfig['vdcp'] = vdcp
# Graph only IR with respect to identified variable
irf_ident_graph = True
modconfig['irf_ident_graph'] = irf_ident_graph
# How many periods for the XDATA IRFs ?
xirfp = 48
modconfig['xirfp'] = xirfp
# Use the svname matrix for alternative shocks?
use_svnames = False
modconfig['use_svnames'] = use_svnames
# Rescale the IRFs ?
rescale = True
modconfig['rescale'] = rescale
# Transform log variables in IRFs into percentages (only useful with rescaling) ?
translog = True
modconfig['translog'] = translog
# Transform the percentage responses back into absolutes from the mean ?
transperc = False
modconfig['transperc'] = transperc
# Add impact matrix to Cholesky responses ?
cholimp = False
modconfig['cholimp'] = cholimp
# How many matrices for MA Representation, this has to be a bit bigger than the number of time periods in the IRs
maxphi = max(vdcp,irfp,xirfp)+2
modconfig['maxphi'] = maxphi
# Boostrap IRF confidence intervals ?
bootstrap = True
modconfig['bootstrap'] = bootstrap
# Draw a horizontal zero line into each IRF Plot
hzline = True
modconfig['hzline'] = hzline
# Should IRFs be annotated
irf_anot = False
modconfig['irf_anot'] = irf_anot
# How thick should the hline be?
hzline_width = 1.0
modconfig['hzline_width'] = hzline_width
# How many effective bootstraps after throwing away useless ones ?
if 'bdraw' not in dir(): bdraw = 1750
modconfig['bdraw'] = bdraw
# Use multicore processors to speed up bootstrap?
multicpu = True
modconfig['multicpu'] = multicpu
# If bootstraps are split into chunks, what is each chunk's size (matters for memory efficiency)
bdraw_chunk = 200
modconfig['bdraw_chunk'] = bdraw_chunk
# Specify number of cpu cores or set to 'auto'
ncpus = 'auto'
modconfig['ncpus'] = ncpus
# Level of significance for bootstrap confidence intervals
signif = 'mix' # implies 1-alpha = 0.66, use 'mix' to graph a variety of CI
modconfig['signif'] = signif
# Boostrap with replacement ?
breplace = False
modconfig['breplace'] = breplace
# What kind of intercept/time trend?
const_term = None # Can be 'None', 'cc' or 'tt'
modconfig['const_term'] = const_term
# Pickle the model run results and settings
pickle_switch = False
modconfig['pickle_switch'] = pickle_switch
########################### use ONE of the identification schemes, not many ###################
# Employ BBE setup of the FAVAR?
use_bbe_ident = True
modconfig['use_bbe_ident'] = use_bbe_ident
# Employ simple Cholesky factorisation of the factor innovation matrix to diagonalize shocks
use_chol_ident = False
modconfig['use_chol_ident'] = use_chol_ident
################################################################################################
####################### This is experimental stuff, need to clarify the difference between the two #####################
# Parametric bootstrap vs. non-parametric bootstrap?
param_bootstrap = False
modconfig['param_bootstrap'] = param_bootstrap
killian_bsinbs = True
modconfig['killian_bsinbs'] = killian_bsinbs
########################################################################################################################
########################################## Graphing options for IRFs and other graphs ##################################
graph_options = {}
graph_options['ftype'] = 'eps'
graph_options['dpi'] = 600
graph_options['labels'] = {}
graph_options['labels']['title'] = False
graph_options['labels']['title_top_only'] = False
graph_options['labels']['xlabel'] = False
graph_options['labels']['ylabel'] = True
graph_options['labels']['xlabel_fs'] = 11
graph_options['labels']['ylabel_fs'] = 11
graph_options['labels']['text_fs'] = 11
graph_options['labels']['title_fs'] = 12
graph_options['labels']['label_fs'] = 9
graph_options['labels']['xticks_fs'] = 9
graph_options['labels']['yticks_fs'] = 9
graph_options['labels']['legend_fs'] = 9
graph_options['labels']['use_tex'] = True
graph_options['lines'] = {}
graph_options['lines']['width'] = 1.5
graph_options['grid'] = True
graph_options['irfs'] = {}
graph_options['irfs']['outer_colour'] = '#a4a4a4'
graph_options['irfs']['inner_colour'] = '#c6c6c6'
graph_options['irfs']['line_colour'] = 'black'
graph_options['irfs']['biased_line'] = True # This allows you to also show the biased IRF when Killian's b-i-b option is on
graph_options['irfs']['biased_line_type'] = 'k--'
modconfig['graph_options'] = graph_options
#########################################################################################################################
# Should recessions be shown in the factor graphs?
plot_rec = True
modconfig['plot_rec'] = plot_rec
# Colour and transparency of recession shades
rec_colour = '#a4a4a4'
rec_transp = 0.2
modconfig['rec_colour'] = rec_colour
modconfig['rec_transp'] = rec_transp
##########################################################################################################################
# Define the names of the vars used
tmp_li = vardic.keys()
tmp_li.sort()
vnames = copy.deepcopy(tmp_li)
modconfig['vnames'] = vnames

# Clean dirs before each run
if do_plots: clean_dirs('/home/emscheffel/Development/repositories/ownhub/jae_first_revise/',modname=modname)



# Create the data modification dictionary
modconfig['tcode'] = vardic


# Configure and start the parallel Python jobserver
ppservers = ()
if modconfig['ncpus'] == 'auto':
    job_server = pp.Server(ncpus='autodetect',ppservers=ppservers)
else:
    job_server = pp.Server(ncpus=modconfig['ncpus'],ppservers=ppservers)


if data_download:
    # Cut off the most recent values as some are missing
    matd = data.values[:-2,:]
    
    # Also create the table for the data
    tmpstr = ''
    tmpstr = tmpstr + r"\begin{sidewaystable}[H]\centering"+"\n"
    tmpstr = tmpstr + r"\caption{Summary of all data used in estimation of SDFM}"+"\n"
    tmpstr = tmpstr + r"\tiny"+"\n"
    tmpstr = tmpstr + r"\begin{tabular}{@{}llllllll@{}}\toprule"+"\n"
    tmpstr = tmpstr + r"No. & Freq. & Convert & Description & Code & Source & Original Units & TCode\\\midrule"+"\n"
    newstr = str(1)+r" & M & None & "+r"Bloom et al.'s policy uncertainty index"+r" & "+r"UNCERT"+r" & "+r"Bloom et al."+r" & "+r"Index"+r" & "+str(vardic['UNCERT'])+r"\\"+"\n"
    tmpstr = tmpstr + newstr
    newstr = str(2)+r" & M & None & "+r"Standard and Poor's 500 US Stock Market Index"+r" & "+r"SPINDEX"+r" & "+r"Bloom et al."+r" & "+r"Index"+r" & "+str(vardic['SPINDEX'])+r"\\"+"\n"
    tmpstr = tmpstr + newstr
    newstr = str(3)+r" & M & None & "+r"US Total Civilian Employment"+r" & "+r"EMP"+r" & "+r"Bloom et al."+r" & "+r"Total no. of persons in 1000s"+r" & "+str(vardic['EMP'])+r"\\"+"\n"
    tmpstr = tmpstr + newstr
    newstr = str(4)+r" & M & None & "+r"Price of Copper in US dollars"+r" & "+r"COPPER"+r" & "+r"Bloom et al."+r" & "+r"US dollars per tonne"+r" & "+str(vardic['COPPER'])+r"\\"+"\n"
    tmpstr = tmpstr + newstr
    varli = list(set(vardic.keys())-set(bloomli))
    varli.sort()
    for i1,namo in enumerate(varli):
        print "Now acquiring data for: "+namo
        resu = Fred(fred_key).get('series','observations', series_id=namo)
        resuf = Fred(fred_key).series(series_id=namo)
        sera = resuf['seriess']['series']
        stringo = 'Identified'
        if namo == 'LNS12032195': stitle = sera['title'].split(',')[0]
        else: stitle = sera['title'].replace(r'&','and')
        freqf = resuf['seriess']['series']['frequency_short']
        if freqf == 'M': convstr = "None"
        elif freqf == 'W': convstr = "Average"
        elif freqf == 'Q': convstr = "Interp."
        else: convstr = "None"
        newstr = str(i1+5)+r" & "+ freqf + " & "+ convstr +" & "+stitle+r" & "+namo+r" & "+r"St. Louis Fed"+r" & "+\
        sera['units']+r" & "+str(vardic[namo])+r"\\"+"\n"
        tmpstr = tmpstr + newstr
        print "Done..."
        valo = [x['value'] for x in resu['observations']['observation']]
        valo2 = numpy.zeros(len(valo))
        for i1,elem in enumerate(valo):
            if elem == '.': valo2[i1] = float(valo2[i1-1])
            else: valo2[i1] = float(elem)
        valo = numpy.array(valo2)
        dato = [x['date'] for x in resu['observations']['observation']]
        # Earlier years of UMCSENT are only available at quarterly intervals
        if namo == 'UMCSENT':
            valo = valo[100:]
            dato = dato[100:]
        if freqf == 'D':
            rango = pandas.period_range(dt.datetime(*[int(x) for x in dato[0].split('-')]), periods=len(dato), freq='D')
            tso = pandas.Series(valo,rango)
            tso2 = tso.resample('M',how=numpy.mean)
        elif freqf == 'W':
            rango = pandas.period_range(dt.datetime(*[int(x) for x in dato[0].split('-')]), periods=len(dato), freq='W')
            tso = pandas.Series(valo,rango)
            tso2 = tso.resample('M',how=numpy.mean)
        elif freqf == 'M':
            rango = pandas.period_range(dt.datetime(*[int(x) for x in dato[0].split('-')]), periods=len(dato), freq='M')
            tso = pandas.Series(valo,rango)
            tso2 = copy.deepcopy(tso)
        elif freqf == 'Q':
            rango = pandas.period_range(dt.datetime(*[int(x) for x in dato[0].split('-')]), periods=len(dato), freq='Q')
            tso = pandas.Series(valo,rango)
            tso2 = tso.resample('M').interpolate()
        valor = tso2['1985-01-01':'2011-08-01']
        dator = valor.index
        if freqf == 'M':
            dator_final = copy.deepcopy(dator)
        valor = valor.values
        if namo not in datadic.keys(): datadic.update({namo:numpy.array(valor)})
    
    tmpstr = tmpstr + r"\bottomrule"+"\n"
    tmpstr = tmpstr + r"\multicolumn{7}{l}{{\bf Notes:} Transformation codes are: 1=levels, 2=first seasonal difference, 3=second seasonal difference, 4=log level, 5=log first seasonal difference, 6=log second seasonal difference,}\\"+"\n"
    tmpstr = tmpstr + r"\multicolumn{7}{l}{7=log hp-filtered monthly data, 19=levels w/o timetrend , 22=log w/o quadratic time trend. Investment data were intrapolated in order to obtain monthly from quarterly data.}"+"\n"
    tmpstr = tmpstr + r"\end{tabular}"+"\n"
    tmpstr = tmpstr + r"\end{sidewaystable}"+"\n"
    if 'table1.tex' in os.listdir('../tables/'):
        os.remove('../tables/table1.tex')
    tmpstr = filter(lambda x: x in string.printable, tmpstr)
    f1 = open('../tables/table1.tex','w')
    f1.write(tmpstr)
    f1.close()


    #CHECK
    por = [x for x in datadic.keys() if datadic[x].shape[0] != 320]
    if len(por) > 0:
        print "Stopping program as some downloaded data is either to long or too short"
        sys.exit()
    # Save the data in the right order
    kago = datadic.keys()
    kago.sort()
    matd = datadic[kago[0]]
    matd = matd.reshape([max(matd.shape),1])
    for elem in kago[1:]:
        matd = numpy.hstack((matd,datadic[elem].reshape([max(datadic[elem].shape),1])))
    
    # Copy raw pandas data into other name
    raw_data = copy.deepcopy(data) # Be careful this matrix is not correctly ordered !
    data = copy.deepcopy(matd)
    trans_data = copy.deepcopy(matd)
    
    # Pickle and save data on disk
    output = open('../data/raw_data.pickle','wb')
    pickle.dump(raw_data,output)
    output.close()
    output = open('../data/data.pickle','wb')
    pickle.dump(matd,output)
    output.close()
    output = open('../data/trans_data.pickle','wb')
    pickle.dump(trans_data,output)
    output.close()
    output = open('../data/dator_final.pickle','wb')
    pickle.dump(dator_final,output)
    output = open('../data/datadic.pickle','wb')
    pickle.dump(datadic,output)    
    output.close()    
else:
    # Load data from disk
    output = open('../data/raw_data.pickle','r')
    raw_data = pickle.load(output)
    output.close()
    output = open('../data/data.pickle','r')
    data = pickle.load(output)
    matd = copy.deepcopy(data)
    output.close()
    output = open('../data/trans_data.pickle','r')
    trans_data = pickle.load(output)
    output.close()
    output = open('../data/dator_final.pickle','r')
    dator_final = pickle.load(output)
    output = open('../data/datadic.pickle','r')
    datadic = pickle.load(output)    
    output.close()



# Plot the uncertainty series with annotations
from matplotlib.ticker import MultipleLocator, FormatStrFormatter
import matplotlib.dates as mdates
majorLocator = MultipleLocator(1)
majorFormatter = FormatStrFormatter('%d')
minorLocator = MultipleLocator(1)
years = mdates.YearLocator()   # every year
months = mdates.MonthLocator()  # every month
yearsFmt = mdates.DateFormatter('%Y')
glopt = modconfig['graph_options']['labels']
gridopt = modconfig['graph_options']['grid']
uncert = datadic['UNCERT']
fig1 = plt.figure()
ax1 = fig1.add_subplot(1,1,1)
if gridopt: ax1.grid()
for label in ax1.get_xticklabels():
    label.set_rotation(55)
if glopt['xlabel']: ax1.set_xlabel('Time',fontsize=glopt['label_fs'])
#if glopt['ylabel']: ax1.set_ylabel('Index 100=(1985-2000)',fontsize=glopt['label_fs'])
datli = [x.end_time.to_datetime() for x in dator_final]
ax1.plot(datli[-len(uncert):],uncert,'k-',linewidth=2.0)
#if glopt['title']: ax1.set_title('Uncertainty Index (Bloom et al.)',fontsize=glopt['title_fs'])
datorli = []
datortxt = []
datorval = []
datoroff = []
datorarr = []
# Balanced budget act of 1985
dato1 = dt.datetime(1985,12,31,23, 59, 59, 999999)
datorli.append(dato1)
datorval.append(175)
datoroff.append((-10,0))
datorarr.append(False)
datortxt.append(r'Bal. Budget Act')
# First Gulf War
dato2 = dt.datetime(1990,8,31,23, 59, 59, 999999)
datorli.append(dato2)
datorval.append(210)
datoroff.append((-30,0))
datorarr.append(False)
datortxt.append(r'1st Gulf War')
# Clinton Election
dato3 = dt.datetime(1993,1,31,23, 59, 59, 999999)
datorli.append(dato3)
datorval.append(185)
datoroff.append((-20,0))
datorarr.append(False)
datortxt.append(r'Clinton Election')
# Bush Election
dato4 = dt.datetime(2001,1,31,23, 59, 59, 999999)
datorli.append(dato4)
datorval.append(145)
datoroff.append((-70,0))
datorarr.append(True)
datortxt.append(r'Bush Election')
# 9/11
dato5 = dt.datetime(2001,9,30,23, 59, 59, 999999)
datorli.append(dato5)
datorval.append(190)
datoroff.append((-16,0))
datorarr.append(False)
datortxt.append(r'9/11')
# 2nd Gulf War
dato6 = dt.datetime(2003,3,31,23, 59, 59, 999999)
datorli.append(dato6)
datorval.append(240)
datoroff.append((-90,0))
datorarr.append(True)
datortxt.append(r'2nd Gulf War')
# Stimulus Debate
dato7 = dt.datetime(2008,3,31,23, 59, 59, 999999)
datorli.append(dato7)
datorval.append(265)
datoroff.append((-110,0))
datorarr.append(True)
datortxt.append(r'Stimulus Debate')
# Lehman and TARP
dato8 = dt.datetime(2008,9,30,23, 59, 59, 999999)
datorli.append(dato8)
datorval.append(285)
datoroff.append((-100,0))
datorarr.append(True)
datortxt.append(r'Lehman \& TARP')
# Obama Election banking crisis
dato9 = dt.datetime(2009,1,31,23, 59, 59, 999999)
datorli.append(dato9)
datorval.append(320)
datoroff.append((-100,0))
datorarr.append(True)
datortxt.append(r'Obama Election')
# Midterms
dato10 = dt.datetime(2010,11,30,23, 59, 59, 999999)
datorli.append(dato10)
datorval.append(310)
datoroff.append((-40,0))
datorarr.append(True)
datortxt.append(r'Midterms')
# Debt ceiling dispute
dato11 = dt.datetime(2011,7,31,23, 59, 59, 999999)
datorli.append(dato11)
datorval.append(338)
datoroff.append((-100,0))
datorarr.append(True)
datortxt.append(r'Debt Ceiling Dispute')
for i1,elem in enumerate(datorli):
    if datoroff[i1] != None:
        indo = datli.index(elem)
        offr = abs(datoroff[i1][0])
        elemo = copy.deepcopy(datli[indo-offr])
    else:
        elemo = copy.deepcopy(elem)
    if not datorarr[i1]:
        ax1.annotate(datortxt[i1],xy=(elem,max(uncert[datli.index(elem)]-10,uncert[datli.index(elem)]+10)),
                     xytext=(elemo,datorval[i1]))
    elif datorarr[i1]:
        ax1.annotate(datortxt[i1],xy=(elem,max(uncert[datli.index(elem)]-10,uncert[datli.index(elem)]+10)),
                     xytext=(elemo,datorval[i1]),
                     arrowprops=dict(facecolor='black',shrink=0.25,width=0.4,headwidth=6.0))
ax1.set_rasterization_zorder(1)
fig1.savefig('../graphs/'+modname+'/'+'UNCERT.'+graph_options['ftype'],bbox_inches='tight',dpi=graph_options['dpi'])
plt.close(fig1)

#sys.exit()


# Function to transform the raw data according to some classification
# 1 = levels
# 2 = first seasonal difference
# 3 = second seasonal difference
# 4 = log level
# 5 = log first seasonal difference
# 6 = log second seasonal difference
# 7 = de-trend log using hp filter monthly data
# 8 = de-trend log using hp filter quarterly data
# 16 = log second seasonal difference
# 17 = (1-L)(1-L^12)
# 18 = log of (1-L)*annualizing factor (i.e. x4 for quarterly and x12 for monthly
# 19 = filter the level using simple time-trend
# 20 = filter the log using simple time-trend
# 21 = filter the level using quadratic time-trend
# 22 = filter the log using quadratic time-trend
# 23 = filter the level using cubic time-trend
# 24 = filter the log using cubic time-trend
freq = modconfig['freq']
shift = 0
freqshift = 1
if freq == 'M':
    freqshift = 12
elif freq == 'Q':
    freqshift = 4
else:
    freqshift = 1

kago = datadic.keys()
kago.sort()
for i1,vname in enumerate(kago):
    if vardic[vname] == 2:
        trans_data[1*freqshift:,i1] = trans_data[1*freqshift:,i1]-trans_data[:-1*freqshift,i1]
        if shift < 1: shift = 1*freqshift
    elif vardic[vname] == 3:
        trans_data[1*freqshift:,i1] = trans_data[1*freqshift:,i1]-trans_data[:-1*freqshift,i1]
        trans_data[2*freqshift:,i1] = trans_data[2*freqshift:,i1]-trans_data[:-2*freqshift,i1]
        if shift < 2: shift = 2*freqshift
    elif vardic[vname] == 4:
        trans_data[:,i1] = numpy.log(trans_data[:,i1])
    elif vardic[vname] == 5:
        trans_data[:,i1] = numpy.log(trans_data[:,i1])
        trans_data[1*freqshift:,i1] = trans_data[1*freqshift:,i1]-trans_data[:-1*freqshift,i1]
        if shift < 11: shift = 1*freqshift
    elif vardic[vname] == 6:
        trans_data[:,i1] = numpy.log(trans_data[:,i1])
        trans_data[1*freqshift:,i1] = trans_data[1*freqshift:,i1]-trans_data[:-1*freqshift,i1]
        trans_data[2*freqshift:,i1] = trans_data[2*freqshift:,i1]-trans_data[:-2*freqshift,i1]
        if shift < 2: shift = 2*freqshift
    elif vardic[vname] == 7:
        trans_data[:,i1] = numpy.log(trans_data[:,i1])
        trans_data[:,i1] = hpf.hpfilter(trans_data[:,i1],129600)[0]
    elif vardic[vname] == 8:
        trans_data[:,i1] = numpy.log(trans_data[:,i1])
        trans_data[:,i1] = hpf.hpfilter(trans_data[:,i1],1600)[0]
    elif vardic[vname] == 18:
        trans_data[:,i1] = numpy.log(trans_data[:,i1])
        if freq == 'Q':
            trans_data[1:,i1] = (trans_data[1:,i1]-trans_data[:-1,i1])*4.0
        elif freq == 'M':
            trans_data[1:,i1] = (trans_data[1:,i1]-trans_data[:-1,i1])*12.0
        if shift < 1: shift = 1
    elif vardic[vname] == 19:
        trans_data[:,i1] = scipy.signal.detrend(trans_data[:,i1])
    elif vardic[vname] == 20:
        trans_data[:,i1] = scipy.signal.detrend(numpy.log(trans_data[:,i1]))
    elif vardic[vname] == 21:
        XX = numpy.ones([max(trans_data[:,i1].shape),1])
        XX = numpy.hstack([XX,numpy.array(range(1,max(trans_data[:,i1].shape)+1,1)).reshape(max(trans_data[:,i1].shape),1)])
        XX = numpy.hstack([XX,numpy.array([x**2 for x in range(1,max(trans_data[:,i1].shape)+1,1)]).reshape(max(trans_data[:,i1].shape),1)])
        bettax = numpy.dot(numpy.linalg.inv(numpy.dot(XX.T,XX)),numpy.dot(XX.T,trans_data[:,i1]))
        trans_data[:,i1] = trans_data[:,i1] - numpy.dot(XX,bettax)
    elif vardic[vname] == 22:
        XX = numpy.ones([max(trans_data[:,i1].shape),1])
        XX = numpy.hstack([XX,numpy.array(range(1,max(trans_data[:,i1].shape)+1,1)).reshape(max(trans_data[:,i1].shape),1)])
        XX = numpy.hstack([XX,numpy.array([x**2 for x in range(1,max(trans_data[:,i1].shape)+1,1)]).reshape(max(trans_data[:,i1].shape),1)])
        bettax = numpy.dot(numpy.linalg.inv(numpy.dot(XX.T,XX)),numpy.dot(XX.T,numpy.log(trans_data[:,i1])))
        trans_data[:,i1] = numpy.log(trans_data[:,i1]) - numpy.dot(XX,bettax)
    elif vardic[vname] == 23:
        XX = numpy.ones([max(trans_data[:,i1].shape),1])
        XX = numpy.hstack([XX,numpy.array(range(1,max(trans_data[:,i1].shape)+1,1)).reshape(max(trans_data[:,i1].shape),1)])
        XX = numpy.hstack([XX,numpy.array([x**2 for x in range(1,max(trans_data[:,i1].shape)+1,1)]).reshape(max(trans_data[:,i1].shape),1)])
        XX = numpy.hstack([XX,numpy.array([x**3 for x in range(1,max(trans_data[:,i1].shape)+1,1)]).reshape(max(trans_data[:,i1].shape),1)])        
        bettax = numpy.dot(numpy.linalg.inv(numpy.dot(XX.T,XX)),numpy.dot(XX.T,trans_data[:,i1]))
        trans_data[:,i1] = trans_data[:,i1] - numpy.dot(XX,bettax)
    elif vardic[vname] == 24:
        XX = numpy.ones([max(trans_data[:,i1].shape),1])
        XX = numpy.hstack([XX,numpy.array(range(1,max(trans_data[:,i1].shape)+1,1)).reshape(max(trans_data[:,i1].shape),1)])
        XX = numpy.hstack([XX,numpy.array([x**2 for x in range(1,max(trans_data[:,i1].shape)+1,1)]).reshape(max(trans_data[:,i1].shape),1)])
        XX = numpy.hstack([XX,numpy.array([x**3 for x in range(1,max(trans_data[:,i1].shape)+1,1)]).reshape(max(trans_data[:,i1].shape),1)])        
        bettax = numpy.dot(numpy.linalg.inv(numpy.dot(XX.T,XX)),numpy.dot(XX.T,numpy.log(trans_data[:,i1])))
        trans_data[:,i1] = numpy.log(trans_data[:,i1]) - numpy.dot(XX,bettax)  

if shift > 0:
    trans_data = trans_data[shift:,:]
    dator_final = dator_final[shift:]
    matd = matd[shift:,:]
max_shift = shift


# Function used to standardize the original data, i.e. de-mean and divide by SD, but save the info !  
trans_dic = {}
data_nonstd = copy.deepcopy(trans_data)
norm_data = copy.deepcopy(trans_data)
for colo in range(0,norm_data.shape[1],1):
    trans_dic[vnames[colo]] = {}
    mean_i = numpy.average(trans_data[:,colo])
    trans_dic[vnames[colo]]['mean'] = copy.deepcopy(mean_i)
    # De-mean the data
    norm_data[:,colo] = trans_data[:,colo] - mean_i
    std_i = numpy.std(trans_data[:,colo])
    trans_dic[vnames[colo]]['std'] = copy.deepcopy(std_i)
    data_nonstd[:,colo] = copy.deepcopy(norm_data[:,colo])
    # Also normalize the data to be ~N(0,1)
    norm_data[:,colo] = norm_data[:,colo]/std_i


W,V = scipy.linalg.eig(numpy.cov(norm_data.T))
W = numpy.real(W)
V = numpy.real(V)
# May have to adjust some factor by changing signs
W[0] = W[0]*(-1.0)
for i in range(V.shape[0]):
    V[i,0] = V[i,0]*(-1.0)
xfitted_qq = numpy.dot(numpy.dot(V[:,:qq_max],V[:,:qq_max].T),norm_data.T).T

if do_plots and do_series_plots:
    # Graph some vars and dump them in graphs directory, here the original, transformed and standardized
    glopt = modconfig['graph_options']['labels']
    gridopt = modconfig['graph_options']['grid']
    plotrec = modconfig['plot_rec']
    modname = modconfig['modname']
    if 'rec_colour' in modconfig.keys(): reccol = modconfig['rec_colour']
    if 'rec_transp' in modconfig.keys(): rectrans = modconfig['rec_transp']     
    for col,name in enumerate(kago):
        fig1 = plt.figure()
        ax1 = fig1.add_subplot(211)
        pyl.subplots_adjust(hspace=0.075)
        if gridopt: ax1.grid()
        timex = [str(x)+'-01' for x in dator_final[-len(trans_data[:,col]):]]
        timex = [dt.datetime(*[int(x) for x in x.split('-')]) for x in timex]
        ax1.plot(timex, trans_data[:,col], color='black',linewidth=2.0)
        if plotrec:
            ylim_0 = 0.0
            ylim_1 = 0.0
            for reco in rdates:
                ylim_0 = ax1.get_ylim()[0]
                ylim_1 = ax1.get_ylim()[1]
                plt.fill([reco[0],reco[1],reco[1],reco[0]],
                         [ylim_0,ylim_0,ylim_1,ylim_1],
                         reccol, alpha=rectrans, edgecolor=reccol)  
        labelo = ax1.get_xticklabels()
        pyl.setp(labelo, visible=False)
        if glopt['title'] and not glopt['title_top_only']: ax1.set_title('Transformed data for '+name,fontsize=glopt['title_fs'])
        elif glopt['title'] and glopt['title_top_only']: ax1.set_title('Transformed and raw data for '+name+'('+str(vardic[name])+')',fontsize=glopt['title_fs'])      
        ax2 = fig1.add_subplot(212)
        if gridopt: ax2.grid()
        for label in ax2.get_xticklabels():
            label.set_rotation(55)
        ax2.plot(timex, matd[:,col], color='black',linewidth=2.0)
        if plotrec:
            for reco in rdates:
                ylim_0 = ax2.get_ylim()[0]
                ylim_1 = ax2.get_ylim()[1]
                plt.fill([reco[0],reco[1],reco[1],reco[0]],
                         [ylim_0,ylim_0,ylim_1,ylim_1],
                         reccol, alpha=rectrans, edgecolor=reccol)  
        if glopt['title'] and not glopt['title_top_only']: ax2.set_title('Raw data for '+name,fontsize=glopt['title_fs'])
        ax2.set_rasterization_zorder(1)        
        fig1.savefig('../graphs/'+modname+'/'+'series/'+name+'.'+graph_options['ftype'], bbox_inches='tight',dpi=graph_options['dpi'])
        plt.close(fig1)
        
        # Save preferred qq fit
        figx = plt.figure()
        axx = figx.add_subplot(111)
        if gridopt: axx.grid()
        for label in axx.get_xticklabels():
            label.set_rotation(55)        
        timex = [str(x)+'-01' for x in dator_final[-len(trans_data[:,col]):]]
        timex = [dt.datetime(*[int(x) for x in x.split('-')]) for x in timex]
        axx.plot(timex, norm_data[:,col], 'k--', label='actual',linewidth=2.0)
        axx.plot(timex, xfitted_qq[:,col], 'k-', label='fitted',linewidth=2.0)
        if plotrec:
            ylim_0 = 0.0
            ylim_1 = 0.0
            for reco in rdates:
                ylim_0 = axx.get_ylim()[0]
                ylim_1 = axx.get_ylim()[1]
                plt.fill([reco[0],reco[1],reco[1],reco[0]],
                         [ylim_0,ylim_0,ylim_1,ylim_1],
                         reccol, alpha=rectrans, edgecolor=reccol)  
        labelo = axx.get_xticklabels()
        axx.set_title('Raw and fitted data for '+name+' ('+str(qq_max)+'Factors)',fontsize=glopt['title_fs'])
        axx.set_rasterization_zorder(1)        
        figx.savefig('../graphs/'+modname+'/'+'fitted/'+name+'.'+graph_options['ftype'], bbox_inches='tight',dpi=graph_options['dpi'])
        plt.close(figx)


# This is the ICp criterion from Ng and Bai 2002 Econometrica    
def compBNICcrit(resmat=None,nobs=None,tnobs=None,nfacs=None,typer=1):
    avgvar = numpy.average(resmat.reshape(resmat.shape[0]*resmat.shape[1],1)**2)
    Cnt = min(nobs,tnobs)
    if typer == 1:
        tailcrit = nfacs*((nobs+tnobs)/(nobs*tnobs))*numpy.log((nobs*tnobs/(nobs+tnobs)))
    elif typer == 2:
        tailcrit = nfacs*((nobs+tnobs)/(nobs*tnobs))*numpy.log(Cnt)
    elif typer == 3:
        tailcrit = nfacs*(numpy.log(Cnt)/Cnt)
    ICp = numpy.log(avgvar)+tailcrit
    return ICp


# This is the PCp criterion from Ng and Bai 2002 Econometrica    
def compBNPCcrit(resmat=None,resmat_max=None,nobs=None,tnobs=None,nfacs=None,typer=1):
    avgvar = numpy.average(resmat.reshape(resmat.shape[0]*resmat.shape[1],1)**2)
    sigmax = numpy.average(resmat_max.reshape(resmat_max.shape[0]*resmat_max.shape[1],1)**2)
    Cnt = min(nobs,tnobs)
    if typer == 1:
        tailcrit = nfacs*sigmax*((nobs+tnobs)/(nobs*tnobs))*numpy.log((nobs*tnobs/(nobs+tnobs)))
    elif typer == 2:
        tailcrit = nfacs*sigmax*((nobs+tnobs)/(nobs*tnobs))*numpy.log(Cnt)
    elif typer == 3:
        tailcrit = nfacs*sigmax*(numpy.log(Cnt)/Cnt)
    PCp = avgvar+tailcrit
    return PCp


# Do the decomposition of the standardized data's VARCOV matrix
#U,s,V = scipy.linalg.svd(numpy.cov(norm_data.T))
icp1_list = []
pcp1_list = []
icp2_list = []
pcp2_list = []
icp3_list = []
pcp3_list = []
screeli = []
W,V = scipy.linalg.eig(numpy.cov(norm_data.T))
W = numpy.real(W)
V = numpy.real(V)
# May have to adjust some factor by changing signs
W[0] = W[0]*(-1.0)
for i in range(V.shape[0]):
    V[i,0] = V[i,0]*(-1.0)
for rr_maxi in range(1,rr_max+1,1):
    facs_max = (1.0/numpy.sqrt(norm_data.shape[0]))*numpy.dot(V[:,:rr_maxi].T,norm_data.T)
    xfitted_max = numpy.dot(numpy.dot(V[:,:rr_maxi],V[:,:rr_maxi].T),norm_data.T).T
    resmat_max = norm_data - xfitted_max
    for rr in range(1,rr_maxi+1,1):
        facs = (1.0/numpy.sqrt(norm_data.shape[0]))*numpy.dot(V[:,:rr].T,norm_data.T)
        xfitted = numpy.dot(numpy.dot(V[:,:rr],V[:,:rr].T),norm_data.T).T
        resmat = norm_data - xfitted
        if rr_maxi == rr_max:
            screeli.append(numpy.average(numpy.ones([min(resmat.shape)])-(numpy.sum(resmat**2,axis=0))/numpy.sum(norm_data**2,axis=0))*100.0)        
        icp1_list.append(compBNICcrit(resmat=resmat,nobs=norm_data.shape[1],tnobs=norm_data.shape[0],nfacs=rr,typer=1))
        pcp1_list.append(compBNPCcrit(resmat=resmat,resmat_max=resmat_max,nobs=norm_data.shape[1],tnobs=norm_data.shape[0],nfacs=rr,typer=1))
        icp2_list.append(compBNICcrit(resmat=resmat,nobs=norm_data.shape[1],tnobs=norm_data.shape[0],nfacs=rr,typer=2))
        pcp2_list.append(compBNPCcrit(resmat=resmat,resmat_max=resmat_max,nobs=norm_data.shape[1],tnobs=norm_data.shape[0],nfacs=rr,typer=2))
        icp3_list.append(compBNICcrit(resmat=resmat,nobs=norm_data.shape[1],tnobs=norm_data.shape[0],nfacs=rr,typer=3))
        pcp3_list.append(compBNPCcrit(resmat=resmat,resmat_max=resmat_max,nobs=norm_data.shape[1],tnobs=norm_data.shape[0],nfacs=rr,typer=3))
    '''
    print icp1_list
    if min(icp1_list) != icp1_list[-1]:
        print 'Found minimum!'
        var = raw_input("Stop here!")
    print pcp1_list
    if min(pcp1_list) != pcp1_list[-1]:
        print 'Found minimum!'
        var = raw_input("Stop here!")
    print '==================='
    print icp2_list
    if min(icp2_list) != icp2_list[-1]:
        print 'Found minimum!'
        var = raw_input("Stop here!")
    print pcp2_list
    if min(pcp2_list) != pcp2_list[-1]:
        print 'Found minimum!'
        var = raw_input("Stop here!")
    print '==================='
    print icp3_list
    if min(icp3_list) != icp3_list[-1]:
        print 'Found minimum!'
        var = raw_input("Stop here!")
    print pcp3_list
    if min(pcp3_list) != pcp3_list[-1]:
        print 'Found minimum!'
        var = raw_input("Stop here!")
    print '==================='
    '''
    icp1_list = []
    pcp1_list = []
    icp2_list = []
    pcp2_list = []
    icp3_list = []
    pcp3_list = []    

screeli2 = copy.deepcopy(screeli)
for i1 in range(1,len(screeli),1):
    screeli2[i1] = screeli[i1] - screeli[i1-1]

# Dump the facor data in matlab format on disk
matlabdat = {}
for elem in range(facs.shape[0]):
    matlabdat['Factor'+str(elem+1)] = facs[elem]
output = open('../data/matlab/factors','wb')
savemat(output,matlabdat)
output.close()
output = open('../data/matlab/factors.csv','wb')
numpy.savetxt(output,facs.T,delimiter=';')
output.close()


if do_plots:
    glopt = modconfig['graph_options']['labels']
    gridopt = modconfig['graph_options']['grid']
    plotrec = modconfig['plot_rec']
    modname = modconfig['modname']
    if 'rec_colour' in modconfig.keys(): reccol = modconfig['rec_colour']
    if 'rec_transp' in modconfig.keys(): rectrans = modconfig['rec_transp']

    # Graph the scree plot
    fig2 = plt.figure()
    ax2 = fig2.add_subplot(111)
    if gridopt: ax2.grid()
    ax2.plot(range(1,len(screeli)+1,1), screeli2, 'ko-',linewidth=2.0)
    ax2.set_ylim([0.0,40.0])
    ax2.set_xlim([0,rr_max+1])
    #ax2.set_title('Marginal scree plot for extracted factors',fontsize=glopt['title_fs'])
    ax2.set_xlabel('Number of extracted factors')
    ax2.set_ylabel('Percentage of variation explained')
    ax2.set_rasterization_zorder(1)    
    fig2.savefig('../graphs/'+modname+'/'+'factors/'+'scree'+'.'+graph_options['ftype'],bbox_inches='tight',dpi=graph_options['dpi'])
    plt.close(fig2)

    # Graph the extracted principal components (i.e. static factors)
    for i1,col in enumerate(range(facs.shape[0])):
        fig1 = plt.figure()
        ax1 = fig1.add_subplot(111)
        timex = [str(x)+'-01' for x in dator_final[-len(trans_data[:,col]):]]
        timex = [dt.datetime(*[int(x) for x in x.split('-')]) for x in timex]
        ax1.plot(timex, facs[col,:], color='black',linewidth=2.0)          
        ax1.set_ylim((-1.0,1.0))
        ylim_0 = ax1.get_ylim()[0]
        ylim_1 = ax1.get_ylim()[1]        
        if gridopt: ax1.grid()
        for label in ax1.get_xticklabels():
            label.set_rotation(55)        
        if plotrec:
            for reco in rdates:
                plt.fill([reco[0],reco[1],reco[1],reco[0]],
                         [ylim_0,ylim_0,ylim_1,ylim_1],
                         reccol, alpha=rectrans, edgecolor=reccol)  
        if graph_options['labels']['title']:
            ax1.set_title(r'Static Factor '+str(col+1),fontsize=glopt['title_fs'])
        ax1.set_rasterization_zorder(1)        
        fig1.savefig('../graphs/'+modname+'/'+'factors/'+'factor'+'_'+str(col+1)+'.'+graph_options['ftype'],bbox_inches='tight',dpi=graph_options['dpi'])
        plt.close(fig1)
    
    # Graph the estimated idiosyncratic shocks
    for col in range(min(resmat_max.shape)):
        fig1 = plt.figure()
        ax1 = fig1.add_subplot(111)
        if gridopt: ax1.grid()
        timex = [str(x)+'-01' for x in dator_final[-len(trans_data[:,col]):]]
        timex = [dt.datetime(*[int(x) for x in x.split('-')]) for x in timex]
        ax1.plot(timex, resmat_max[:,col], color='black',linewidth=2.0)
        for label in ax1.get_xticklabels():
            label.set_rotation(55)        
        if plotrec:
            for reco in rdates:
                ylim_0 = ax1.get_ylim()[0]
                ylim_1 = ax1.get_ylim()[1]
                plt.fill([reco[0],reco[1],reco[1],reco[0]],
                         [ylim_0,ylim_0,ylim_1,ylim_1],
                         reccol, alpha=rectrans, edgecolor=reccol) 
        ax1.set_title('Estimated idiosyncratic shock for variable: '+vnames[col],fontsize=glopt['title_fs'])
        ax1.set_rasterization_zorder(1)        
        fig1.savefig('../graphs/'+modname+'/'+'idio_shocks/'+vnames[col]+'.'+graph_options['ftype'],bbox_inches='tight',dpi=graph_options['dpi'])
        plt.close(fig1)
    

    # Graphs the Stock and Watson R^2 bar chart graphs for the first 4 factors
    patterns = ['//', 'x' ,'/', '//']*25
    patternsc = ['#D0D3F7','#9092AB','#D0D3F7','#9092AB',]*25
    for faco in range(qq_max):
        XX = facs[faco,:]
        fig1 = plt.figure(figsize=(21,7))
        ax1 = fig1.add_subplot(111)

        def autolabel(rects,namocs):
        # attach some text labels
            for i1,rect in enumerate(rects):
                height = rect.get_height()
                ax1.text(rect.get_x()+rect.get_width()/2., height+0.02, namocs[i1],\
                         ha='center', va='bottom', rotation='vertical', fontsize=10)

        if gridopt:
            ax1.xaxis.grid(True)            
            ax1.grid()
        ax1.set_ylim([0.0,1.0])
        if graph_options['labels']['title']:
            ax1.set_ylabel('R-squared (from regression on factor '+str(faco+1)+')')
        plt.tick_params(\
            axis='x',          # changes apply to the x-axis
            which='both',      # both major and minor ticks are affected
            bottom='off',      # ticks along the bottom edge are off
            top='off',         # ticks along the top edge are off
            labelbottom='off')        
        # Compute a regression which can be used to select suitable IRFs
        R2s = [numpy.corrcoef(trans_data[:,i2].flatten(),XX.flatten())[0,1]**2 for i2 in range(trans_data.shape[1])]
        counto1=0
        counto2=0
        keyli = groupdic.keys()
        keyli.sort()
        for ii,keyo in enumerate(keyli):
            categ = range(len(groupdic[keyo])+2)
            categ = [x+counto1 for x in categ]
            counto2 = categ[-1]
            if ii == 0: pass
            else: plt.vlines(counto1,0.0,1.0,linewidth=2.0)
            indox = [vnames.index(x) for x in groupdic[keyo]]
            namox = [vnames[i1] for i1 in indox]
            recto = ax1.bar(categ,[R2s[y] for y in indox]+[0.0, 0.0,], color=patternsc[ii], edgecolor='black', hatch=patterns[ii])
            autolabel(recto[:-2],namox)
            if ii != 0: ax1.annotate(keyo,xy=[0.0,0.0],xytext=[counto1+0.5,0.97],rotation='horizontal')
            else: ax1.annotate(keyo,xy=[0.0,0.0],xytext=[counto1+0.5,0.97],rotation='horizontal')
            counto1 = copy.deepcopy(counto2)
        ax1.set_rasterization_zorder(1)        
        fig1.savefig('../graphs/'+modname+'/'+'factors/'+'factorR2'+'_'+str(faco+1)+'.'+graph_options['ftype'],bbox_inches='tight',dpi=graph_options['dpi'])
        plt.close(fig1)


# Define function which returns parameterized 3-dimensional orthonormal rotation matrix
def rotmat3d(aa,bb,cc):
    AA = numpy.array([[numpy.cos(aa),numpy.sin(aa),0],\
                      [-numpy.sin(aa),numpy.cos(aa),0],\
                      [0,0,1]])
    
    MM = numpy.array([[numpy.cos(bb),0,numpy.sin(bb)],\
                      [0,1,0],\
                      [-numpy.sin(bb),0,numpy.cos(bb)]])
    
    CC = numpy.array([[1,0,0],\
                      [0,numpy.cos(cc),numpy.sin(cc)],\
                      [0,-numpy.sin(cc),numpy.cos(cc)]])
    
    return numpy.dot(AA,numpy.dot(MM,CC))

# Sanity check with statsmodels
varres = vm.VAR(facs.T)
varres = varres.fit(maxlags=1,trend='nc')


def rotmat4d(aa,bb,cc,dd,ee,ff):
    SS=numpy.mat([[0.0,aa,bb,dd],
                  [-aa,0.0,cc,ee],
                  [-bb,-cc,0.0,ff],
                  [-dd,-ee,-ff,0.0]])

    Theta = numpy.sqrt(aa**2+bb**2+cc**2+dd**2+ee**2+ff**2)
    invLength = 1.0/Theta

    aa *= invLength
    bb *= invLength
    cc *= invLength
    dd *= invLength
    ee *= invLength
    ff *= invLength

    delta = aa*ff - bb*ee + cc*dd
    delta2 = delta**2
    p = numpy.sqrt(1.0 - 4.0*delta2)
    alpha = Theta * numpy.sqrt(0.5*(1.0 - p))
    beta = Theta * numpy.sqrt(0.5*(1.0 + p))
    invDenom = 1.0/(beta*beta - alpha*alpha)

    cosa = numpy.cos(alpha)
    sina = numpy.sin(alpha)
    cosb = numpy.cos(beta)
    sinb = numpy.sin(beta)

    k0 = (beta*beta*cosa - alpha*alpha*cosb)*invDenom
    k1 = (beta*beta*sina/alpha - alpha*alpha*sinb/beta)*invDenom
    k2 = (cosa - cosb)*invDenom
    k3 = (sina/alpha - sinb/beta)*invDenom

    RR = k0*numpy.mat(numpy.identity(4)) + k1*SS + k2*(SS**2) + k3*(SS**3)

    #Check for nan before returning, else return identity
    if numpy.isnan(numpy.sum(numpy.sum(RR,axis=0))):
        RR = numpy.mat(numpy.identity(4))

    return RR.A



##############################################
# Estimate the VAR(1) in the dynamic factors #
##############################################
facsd_y = copy.deepcopy(facs.T[1:,:qq_max])
facsd_1 = copy.deepcopy(facs.T[:-1,:qq_max])
yxcovd = (1.0/float(max(norm_data[1:].shape)))*(numpy.dot(norm_data[1:].T,norm_data[:-1]))
xxcovd = (1.0/float(max(norm_data.shape)))*(numpy.dot(norm_data.T,norm_data))
DeltaNd = numpy.dot(numpy.dot(V[:,:qq_max].T,xxcovd),V[:,:qq_max])
WCWd = numpy.dot(numpy.dot(V[:,:qq_max].T,yxcovd),V[:,:qq_max])
bettaxd = numpy.dot(WCWd,numpy.linalg.inv(DeltaNd))
var_resmatd = facsd_y - numpy.dot(bettaxd,facsd_1.T).T

# Extract q principal components from residuals to get the q shocks
BDBd = numpy.dot(numpy.dot(bettaxd,DeltaNd),bettaxd.T)
Wxd,Vxd = scipy.linalg.eig(numpy.cov(var_resmatd.T))
Wxd = numpy.real(Wxd)
Vxd = numpy.real(Vxd)
sfacsd = (1.0/numpy.sqrt(max(var_resmatd.shape)))*numpy.dot(Vxd[:,:qq_max].T,var_resmatd.T)
sfacsd = sfacsd.T
WCWd = numpy.dot(numpy.dot(V[:,:qq_max].T,yxcovd),V[:,:qq_max])
MMd = numpy.sqrt(Wxd[:qq_max].T)*numpy.identity(qq_max)
KKd = Vxd[:,:qq_max]


"""
HHa = numpy.arange(0.0,2.0*numpy.pi,0.15)
HHb = numpy.arange(0.0,2.0*numpy.pi,0.15)
HHc = numpy.arange(0.0,2.0*numpy.pi,0.15)
aamsign = restrim.T
HHai = 0
HHbi = 0
HHci = 0
rotmatinds = []
aamsign = numpy.zeros([qq_max,qq_max])
print "Looking for suitable unitary rotation matrix..."
for i1,indo1 in  enumerate(HHa):
    print "Outer index at: "+str(i1+1)+"/"+str(max(HHa.shape))
    for i2,indo2 in enumerate(HHb):
        print "Middle index at: "+str(i2+1)+"/"+str(max(HHb.shape))
        for i3,indo3 in enumerate(HHc):
            HHd = rotmat3d(indo1,indo2,indo3)
            # Recursively compute phi matrices by taking matrix powers of bettax
            kd = max(KKd.shape)
            pd = 1
            phis_compd = numpy.zeros((maxphi+1,kd,kd))
            phis_compd[0] = copy.deepcopy(HHd)
            for i in xrange(1, maxphi + 1):
                phis_compd[i] = numpy.dot(phis_compd[i-1],bettaxd)
            # Compute the sign matrix of the impact
            for rowo in xrange(qq_max):
                for colo in xrange(qq_max):
                    aamsign[rowo,colo] = phis_compd[1][rowo,colo]/abs(phis_compd[1][rowo,colo])
            if numpy.all(aamsign == restrim):
                print "Rotation matrix found with: a:"+str(HHa[i1])+", b:"+str(HHb[i2])+", c:"+str(HHc[i3])
                HHai = i1
                HHbi = i2
                HHci = i3
                rotmatinds.append([HHai,HHbi,HHci])

if HHai == 0 and HHbi == 0 and HHci == 0:
    print "Unitary matrix not found... ABORTING!"
    strogo = raw_input("Press any button to stop the simulation!")
    sys.exit()
# Now copy HHd into HH
HHai,HHbi,HHci = rotmatinds[-1]
HH = copy.deepcopy(rotmat3d(HHa[HHai],HHb[HHbi],HHc[HHci]))
"""


incro = 0.2
HHa = numpy.arange(-1.0, 0.99, incro)
HHb = numpy.arange(-1.0, 0.99, incro)
HHc = numpy.arange(-1.0, 0.99, incro)
HHd = numpy.arange(-1.0, 0.99, incro)
HHe = numpy.arange(-1.0, 0.99, incro)
HHf = numpy.arange(-1.0, 0.99, incro)

aamsign = restrim.T
HHai = 0
HHbi = 0
HHci = 0
HHdi = 0
HHei = 0
HHfi = 0

rotmatinds = []
aamsign = numpy.zeros([qq_max,qq_max],dtype=numpy.int32)
print "Looking for suitable unitary rotation matrix..."
for i1,indo1 in  enumerate(HHa):
    print "Outer index at: "+str(i1+1)+"/"+str(max(HHa.shape))
    for i2,indo2 in enumerate(HHb):
        print "Middle index at: "+str(i2+1)+"/"+str(max(HHb.shape))
        for i3,indo3 in enumerate(HHc):
            print "Inner index at: "+str(i3+1)+"/"+str(max(HHc.shape))
            for i4,indo4 in enumerate(HHd):
                for i5,indo5 in enumerate(HHe):
                    for i6,indo6 in enumerate(HHf):
                        HHdd = rotmat4d(indo1, indo2, indo3, indo4, indo5, indo6)
                        # Compute impact
                        impact = numpy.dot(HHdd,bettaxd)
                        for rowo in xrange(qq_max):
                            for colo in xrange(qq_max):
                                if restrim[rowo,colo] != 99:
                                    aamsign[rowo,colo] = int(impact[rowo,colo]/abs(impact[rowo,colo]))
                                else: aamsign[rowo,colo] = 99
                        if numpy.all(aamsign == restrim):
                            print "Rotation matrix found with: a:"+str(HHa[i1])+", b:"+str(HHb[i2])+", c:"+str(HHc[i3])
                            HHai = i1
                            HHbi = i2
                            HHci = i3
                            HHai = i4
                            HHbi = i5
                            HHci = i6
                            rotmatinds.append([HHai,HHbi,HHci,HHdi,HHei,HHfi])

if HHai == 0 and HHbi == 0 and HHci == 0 and HHdi == 0 and HHei == 0 and HHfi == 0:
    print "Unitary matrix not found... ABORTING!"
    strogo = raw_input("Press any button to stop the simulation!")
    sys.exit()

# Now copy HHd into HH, take the first set found
HHai,HHbi,HHci,HHdi,HHei,HHfi = rotmatinds[0]
HH = copy.deepcopy(rotmat4d(HHa[HHai],HHb[HHbi],HHc[HHci],HHd[HHdi],HHe[HHei],HHf[HHfi]))

# Recursively compute phi matrices by taking matrix powers of bettax
kd = max(KKd.shape)
pd = 1
phis_compd = numpy.zeros((maxphi+1,kd,kd))
phis_compd[0] = copy.deepcopy(HH)
for i in xrange(1, maxphi + 1):
    phis_compd[i] = numpy.dot(phis_compd[i-1],bettaxd)
irfsd = copy.deepcopy(phis_compd)


if do_plots:
    # Plot the impulse response functions
    gridopt = modconfig['graph_options']['grid']
    glopt = modconfig['graph_options']['labels']
    for shocko in xrange(irfsd.shape[-1]):
        for i2,varo in enumerate(xrange(irfsd.shape[1])):
            title = r'Response of variable: '+'FACTOR'+str(i2+1)+' to shock '+str(shocko+1)
            fig1 = plt.figure()
            ax1 = fig1.add_subplot(111)
            if gridopt: ax1.grid()
            pswitch = False
            if vardic[vnames[varo]] in [7,8,20,22,24]:
                ax1.plot(irfsd[:,varo,shocko].flatten()*100.0, color='black',linewidth=2.0)
                pswitch = True
            else:
                ax1.plot(irfsd[:,varo,shocko].flatten(), color='black',linewidth=2.0)
            ax1.set_title(title,fontsize=glopt['title_fs'])
            ax1.set_rasterization_zorder(1)            
            fig1.savefig('../graphs/'+modname+'/irfs/'+'aashock_'+str(shocko+1)+'/'+'FACTOR'+str(i2+1)+'_'+str(shocko+1)+'.'+graph_options['ftype'],bbox_inches='tight',dpi=graph_options['dpi'])
            plt.close(fig1)     
    


#############################################
# Estimate the VAR(1) in the static factors #
#############################################
facs_y = copy.deepcopy(facs.T[1:,:])
facs_1 = copy.deepcopy(facs.T[:-1,:])
yxcov = (1.0/float(max(norm_data[1:].shape)))*(numpy.dot(norm_data[1:].T,norm_data[:-1]))
xxcov = (1.0/float(max(norm_data.shape)))*(numpy.dot(norm_data.T,norm_data))
DeltaN = numpy.dot(numpy.dot(V[:,:rr_max].T,xxcov),V[:,:rr_max])
WCW = numpy.dot(numpy.dot(V[:,:rr_max].T,yxcov),V[:,:rr_max])
bettax = numpy.dot(WCW,numpy.linalg.inv(DeltaN))
var_resmat = facs_y - numpy.dot(bettax,facs_1.T).T

# Extract q principal components from residuals to get the q shocks
BDB = numpy.dot(numpy.dot(bettax,DeltaN),bettax.T)
Wx,Vx = scipy.linalg.eig(numpy.cov(var_resmat.T))
Wx = numpy.real(Wx)
Vx = numpy.real(Vx)
sfacs = (1.0/numpy.sqrt(max(var_resmat.shape)))*numpy.dot(Vx[:,:qq_max].T,var_resmat.T)
sfitted = numpy.dot(numpy.dot(Vx[:,:qq_max],Vx[:,:qq_max].T),var_resmat.T).T
sfacs = sfacs.T
WCW = numpy.dot(numpy.dot(V[:,:rr_max].T,yxcov),V[:,:rr_max])
MM = numpy.sqrt(Wx[:qq_max].T)*numpy.identity(qq_max)
KK = Vx[:,:qq_max]

# Recursively compute phi matrices by taking matrix powers of bettax
KMH = numpy.dot(KK,numpy.dot(MM,HH))
k = max(KK.shape)
p = 1
xcov = numpy.cov(norm_data.T)
QQ = (1.0/numpy.sqrt(k))*numpy.dot(xcov,V[:,:rr_max])
phis_comp = numpy.zeros((maxphi+1,k,qq_max))
phis_comp[0] = copy.deepcopy(KMH)
for i in xrange(1, maxphi + 1):
    phis_comp[i] = numpy.dot(bettax,phis_comp[i-1])
irfs = numpy.array([numpy.dot(QQ,x) for x in phis_comp])


# Also compute the FEVD now that we have identified unitary matrix HH
fevdm = numpy.zeros([vdcp,max(QQ.shape),qq_max])
marep = numpy.zeros([vdcp,rr_max,qq_max])
marep[0] = chain_dot(KK,MM,numpy.identity(qq_max))
for elem in xrange(1,vdcp,1):
    marep[elem] += chain_dot(bettax,marep[elem-1])
k = rr_max
forc_covs = numpy.zeros((vdcp,max(QQ.shape),max(QQ.shape)))
prior = numpy.zeros((max(QQ.shape), max(QQ.shape)))
for h in xrange(vdcp):
    phi = marep[h]
    var = chain_dot(QQ,phi,numpy.identity(qq_max),phi.T,QQ.T)
    forc_covs[h] = prior = prior + var
for varo in xrange(fevdm.shape[1]):
    for shocko in xrange(fevdm.shape[2]):
        fevdm[:,varo,shocko] = ((irfs[:vdcp]**2)[:,varo,shocko].cumsum(axis=0)/forc_covs[:,varo,varo].T)*100.0

if do_plots:
    # Plot the FEVD graphs
    gridopt = modconfig['graph_options']['grid']
    glopt = modconfig['graph_options']['labels']
    for varo in xrange(fevdm.shape[1]):
        title = r'FEVD of variable: '+vnames[varo]
        fig1 = plt.figure()
        ax1 = fig1.add_subplot(111)
        if gridopt: ax1.grid()
        ax1.set_title(title,fontsize=glopt['title_fs'])
        ax1.set_ylabel(r'FEVD',fontsize=glopt['ylabel_fs'])
        ax1.set_xlabel(r'Forecast Horizon',fontsize=glopt['ylabel_fs'])
        ax1.set_ylim(0.0,100.0)
        for shocko in xrange(fevdm.shape[-1]):
            if shocko == 0: ax1.plot(fevdm[:,varo,shocko].flatten(), 'k-', label='Factor Shock 1',linewidth=2.0)
            elif shocko == 1: ax1.plot(fevdm[:,varo,shocko].flatten(), 'k--', label='Factor Shock 2',linewidth=2.0)
            elif shocko == 2: ax1.plot(fevdm[:,varo,shocko].flatten(), 'k+', label='Factor Shock 3',linewidth=2.0)
            elif shocko == 3: ax1.plot(fevdm[:,varo,shocko].flatten(), 'kx', label='Factor Shock 4',linewidth=2.0)
        plt.legend()
        ax1.set_rasterization_zorder(1)        
        fig1.savefig('../graphs/'+modname+'/fevds/'+vnames[varo]+'.'+graph_options['ftype'],bbox_inches='tight',dpi=graph_options['dpi'])
        plt.close(fig1)
        


gridopt = modconfig['graph_options']['grid']
glopt = modconfig['graph_options']['labels']


namo = 'UMCSENT'
varo = vnames.index(namo)
fig1 = plt.figure()
ax1 = fig1.add_subplot(111)
if gridopt: ax1.grid()
ax1.set_ylabel(r'FEVD',fontsize=glopt['ylabel_fs'])
ax1.set_xlabel(r'Forecast Horizon',fontsize=glopt['ylabel_fs'])
ax1.set_ylim(0.0,100.0)
for shocko in xrange(fevdm.shape[-1]):
    if shocko == 0: ax1.plot(fevdm[:,varo,shocko].flatten(), 'k-', label='Factor Shock 1',linewidth=2.0)
    elif shocko == 1: ax1.plot(fevdm[:,varo,shocko].flatten(), 'k--', label='Factor Shock 2',linewidth=2.0)
    elif shocko == 2: ax1.plot(fevdm[:,varo,shocko].flatten(), 'k+', label='Factor Shock 3',linewidth=2.0)
    elif shocko == 3: ax1.plot(fevdm[:,varo,shocko].flatten(), 'kx', label='Factor Shock 4',linewidth=2.0)
plt.legend()
ax1.set_rasterization_zorder(1)        
fig1.savefig('../graphs/'+modname+'/'+vnames[varo]+'.'+graph_options['ftype'],bbox_inches='tight',dpi=graph_options['dpi'])
plt.close(fig1)

namo = 'HOUST'
varo = vnames.index(namo)
fig1 = plt.figure()
ax1 = fig1.add_subplot(111)
if gridopt: ax1.grid()
ax1.set_ylabel(r'FEVD',fontsize=glopt['ylabel_fs'])
ax1.set_xlabel(r'Forecast Horizon',fontsize=glopt['ylabel_fs'])
ax1.set_ylim(0.0,100.0)
for shocko in xrange(fevdm.shape[-1]):
    if shocko == 0: ax1.plot(fevdm[:,varo,shocko].flatten(), 'k-', label='Factor Shock 1',linewidth=2.0)
    elif shocko == 1: ax1.plot(fevdm[:,varo,shocko].flatten(), 'k--', label='Factor Shock 2',linewidth=2.0)
    elif shocko == 2: ax1.plot(fevdm[:,varo,shocko].flatten(), 'k+', label='Factor Shock 3',linewidth=2.0)
    elif shocko == 3: ax1.plot(fevdm[:,varo,shocko].flatten(), 'kx', label='Factor Shock 4',linewidth=2.0)
plt.legend()
ax1.set_rasterization_zorder(1)        
fig1.savefig('../graphs/'+modname+'/'+vnames[varo]+'.'+graph_options['ftype'],bbox_inches='tight',dpi=graph_options['dpi'])
plt.close(fig1)
    

if do_plots:
    # Plot the impulse response functions
    gridopt = modconfig['graph_options']['grid']
    glopt = modconfig['graph_options']['labels']
    for shocko in xrange(irfs.shape[-1]):
        for varo in xrange(irfs.shape[1]):
            title = r'Response of variable: '+vnames[varo]+' to shock '+str(shocko+1)
            fig1 = plt.figure()
            ax1 = fig1.add_subplot(111)
            if gridopt: ax1.grid()
            pswitch=False
            if vardic[vnames[varo]] in [7,8,20,22,24]:
                ax1.plot(irfs[:,varo,shocko].flatten()*100.0, color='black',linewidth=2.0)
            else:
                ax1.plot(irfs[:,varo,shocko].flatten(), color='black',linewidth=2.0)
            ax1.set_title(title,fontsize=glopt['title_fs'])
            ax1.set_xlim([0,60])
            ax1.set_xlabel('Time after shock')
            ax1.set_ylabel('Response'+pswitch*' in percentages')
            ax1.set_rasterization_zorder(1)            
            fig1.savefig('../graphs/'+modname+'/irfs/'+'ashock_'+str(shocko+1)+'/'+vnames[varo]+'_'+str(shocko+1)+'.'+graph_options['ftype'],bbox_inches='tight',dpi=graph_options['dpi'])
            plt.close(fig1)     
    


    # Plot the money market IRFs
    gridopt = modconfig['graph_options']['grid']
    glopt = modconfig['graph_options']['labels']
    title = r'Response of money markets to uncertainty shock'
    fig1 = plt.figure()
    ax1 = fig1.add_subplot(111)
    if gridopt: ax1.grid()
    stli = ['-','--','-.',':','.',',']
    indor = []
    indor.append(vnames.index('GS1'))
    indor.append(vnames.index('GS2'))
    indor.append(vnames.index('GS3'))
    indor.append(vnames.index('GS5'))
    indor.append(vnames.index('GS7'))
    indor.append(vnames.index('GS10'))
    for i1,elem in enumerate(indor):
        ax1.plot(irfs[:,elem,qq_max-1].flatten()*trans_dic[vnames[elem]]['std'], 'k'+stli[i1], label=vnames[elem],linewidth=2.0)
    #ax1.set_title(title,fontsize=glopt['title_fs'])
    plt.legend(loc=4)
    ax1.set_xlim([0,60])
    ax1.set_xlabel(r'Time periods after shock',fontsize=glopt['xlabel_fs'])
    ax1.set_ylabel(r'Response in percentage points',fontsize=glopt['ylabel_fs'])
    ax1.set_rasterization_zorder(1)    
    fig1.savefig('../graphs/'+modname+'/irfs/moneym.'+graph_options['ftype'], bbox_inches='tight',dpi=graph_options['dpi'])
    plt.close(fig1)
    

    # Plot the commodity market IRFs
    gridopt = modconfig['graph_options']['grid']
    glopt = modconfig['graph_options']['labels']
    title = r'Response of commodity markets to uncertainty shock'
    fig1 = plt.figure()
    ax1 = fig1.add_subplot(111)
    if gridopt: ax1.grid()
    indor = []
    indor.append(vnames.index('COPPER'))
    indor.append(vnames.index('OILPRICE'))
    for i1,elem in enumerate(indor):
        ax1.plot(irfs[:,elem,qq_max-1].flatten()*trans_dic[vnames[elem]]['std']*100.0, 'k'+stli[i1], label=vnames[elem],linewidth=2.0)
    #ax1.set_title(title,fontsize=glopt['title_fs'])
    plt.legend(loc=4)
    ax1.set_xlim([0,60])
    ax1.set_xlabel(r'Time periods after shock',fontsize=glopt['xlabel_fs'])
    ax1.set_ylabel(r'Response in percentages',fontsize=glopt['ylabel_fs'])
    ax1.set_rasterization_zorder(1)    
    fig1.savefig('../graphs/'+modname+'/irfs/comm.'+graph_options['ftype'], bbox_inches='tight',dpi=graph_options['dpi'])
    plt.close(fig1)
    

    # Plot the stock market IRFs
    gridopt = modconfig['graph_options']['grid']
    glopt = modconfig['graph_options']['labels']
    title = r'Response of stock market to uncertainty shock'
    fig1 = plt.figure()
    ax1 = fig1.add_subplot(111)
    if gridopt: ax1.grid()
    indor = []
    indor.append(vnames.index('SPINDEX'))
    for i1,elem in enumerate(indor):
        ax1.plot(irfs[:,elem,qq_max-1].flatten()*trans_dic[vnames[elem]]['std']*100.0, 'k'+stli[i1], label=vnames[elem],linewidth=2.0)
    #ax1.set_title(title,fontsize=glopt['title_fs'])
    plt.legend(loc=4)
    ax1.set_xlim([0,60])
    ax1.set_xlabel(r'Time periods after shock',fontsize=glopt['xlabel_fs'])
    ax1.set_ylabel(r'Response in percentages',fontsize=glopt['ylabel_fs'])
    ax1.set_rasterization_zorder(1)    
    fig1.savefig('../graphs/'+modname+'/irfs/spindex.'+graph_options['ftype'], bbox_inches='tight',dpi=graph_options['dpi'])
    plt.close(fig1)
    

    # Plot the other IRFs
    gridopt = modconfig['graph_options']['grid']
    glopt = modconfig['graph_options']['labels']
    title = r'Response of real economy to uncertainty shock'
    fig1 = plt.figure()
    ax1 = fig1.add_subplot(111)
    if gridopt: ax1.grid()
    indor = []
    indor.append(vnames.index('IPDCONGD'))
    indor.append(vnames.index('INDPRO'))
    indor.append(vnames.index('EMP'))
    for i1,elem in enumerate(indor):
        ax1.plot(irfs[:,elem,qq_max-1].flatten()*trans_dic[vnames[elem]]['std']*100.0, 'k'+stli[i1], label=vnames[elem],linewidth=2.0)
    #ax1.set_title(title,fontsize=glopt['title_fs'])
    plt.legend(loc=4)
    ax1.set_xlim([0,60])
    ax1.set_xlabel(r'Time periods after shock',fontsize=glopt['xlabel_fs'])
    ax1.set_ylabel(r'Response in percentages',fontsize=glopt['ylabel_fs'])
    ax1.set_rasterization_zorder(1)    
    fig1.savefig('../graphs/'+modname+'/irfs/econact.'+graph_options['ftype'], bbox_inches='tight',dpi=graph_options['dpi'])
    plt.close(fig1)
    



# Generate the SIGNS matrices which are later used to check the quality of bootstraps
msigns = numpy.zeros([irfs.shape[1],irfs.shape[-1]])
for shocko in xrange(irfs.shape[-1]):
    msigns[:,shocko] = irfs[0,:,shocko]/numpy.abs(irfs[0,:,shocko])
# Also generate a pseudo-derivatives data to check directional change as well
mderiv = numpy.zeros([irfs.shape[1],irfs.shape[-1],3])
for varo in xrange(irfs.shape[1]):
    for shocko in xrange(irfs.shape[-1]):
        mderiv[varo,shocko,0] = irfs[offset1,varo,shocko] - irfs[0,varo,shocko]
        mderiv[varo,shocko,0] = mderiv[varo,shocko,0]/abs(mderiv[varo,shocko,0])
        mderiv[varo,shocko,1] = irfs[offset1+offset2,varo,shocko] - irfs[offset1,varo,shocko]
        mderiv[varo,shocko,1] = mderiv[varo,shocko,1]/abs(mderiv[varo,shocko,1])
        mderiv[varo,shocko,2] = (abs(irfs[offset1,varo,shocko] - irfs[0,varo,shocko])/irfs[offset1,varo,shocko])*100.0


###################################################################################################
# To prepare boostrap we need to estimate multiple univariate regression on idiosyncractic errors #
###################################################################################################
max_lags = 10
nobss = max(resmat_max.shape)
bic_mat = numpy.zeros([min(resmat_max.shape),max_lags])
# This matrix records all of the estimated betta's and the XXs for each error term for later use
est_mat = []
for varo in range(min(resmat_max.shape)):
    varest_mat = []
    shocko = resmat_max[:,varo]
    sxx = copy.deepcopy(shocko)
    sxx = sxx.reshape([len(sxx),1])
    syy = copy.deepcopy(shocko)
    syy = syy.reshape([len(syy),1])
    for lago in range(1,max_lags+1,1):
        syy = syy[1:,:]
        sxx = sxx[:-1,:]
        if lago == 1:
            # Lagged matrix is simple as only contains one lag
            bettas = numpy.dot(numpy.linalg.inv(numpy.dot(sxx.T,sxx)),numpy.dot(sxx.T,syy))
            serr = syy - numpy.dot(sxx,bettas)
            bic_mat[varo,lago-1] = nobss*numpy.log(numpy.var(serr))+max(bettas.shape)*numpy.log(nobss)
            sxx_temp = copy.deepcopy(sxx)
            syy_temp = copy.deepcopy(syy)            
            #Reset the matrices when done
            sxx = copy.deepcopy(shocko)
            sxx = sxx.reshape([len(sxx),1])
            syy = copy.deepcopy(shocko)
            syy = syy.reshape([len(syy),1])              
        else:
            # Build the lagged XX matrix
            for jj in range(1,lago,1):
                sxx = numpy.hstack((sxx[1:,:],sxx[:-1,-1].reshape([len(sxx[:-1,-1]),1])))
                syy = syy[1:,:]
            #print "For: "+str(lago)+" the shape size is: sxx:"+str(sxx.shape)+" syy:"+str(syy.shape)
            bettas = numpy.dot(numpy.linalg.inv(numpy.dot(sxx.T,sxx)),numpy.dot(sxx.T,syy))
            serr = syy - numpy.dot(sxx,bettas)
            bic_mat[varo,lago-1] = nobss*numpy.log(numpy.var(serr))+max(bettas.shape)*numpy.log(nobss)
            sxx_temp = copy.deepcopy(sxx)
            syy_temp = copy.deepcopy(syy)
            #Reset the matrices when done
            sxx = copy.deepcopy(shocko)
            sxx = sxx.reshape([len(sxx),1])
            syy = copy.deepcopy(shocko)
            syy = syy.reshape([len(syy),1])
        varest_mat.append([bettas,sxx_temp])
    est_mat.append(varest_mat)
# Determine the minimum BIC criterion for each idiosyncratic component and choose desirable lag length
minima = numpy.min(bic_mat,axis=1)
laginds = []
for i1,poso in enumerate(range(max(bic_mat.shape))):
    laginds.append(list(bic_mat[poso,:]).index(minima[poso]))
for i1,elem in enumerate(laginds):
    indor = (max(resmat_max.shape)-max(est_mat[i1][elem][1].shape))
    est_mat[i1] = est_mat[i1][elem]
    # Also add the residuals and standard errors
    resido = resmat_max[indor:,i1].reshape([max(resmat_max[indor:,i1].shape),1])-numpy.dot(est_mat[i1][1],est_mat[i1][0])
    stdo = numpy.std(resido)
    est_mat[i1].append(stdo)
    est_mat[i1].append(resido)
est_mat = numpy.array(est_mat)
maxsshift = 0
for elem in [x[0] for x in est_mat]:
    if len(elem) > maxsshift: maxsshift = len(elem)
nnobs = max(norm_data.shape) - maxsshift
# Generate the stacked estmat for later use
idiocofmat = numpy.zeros([min(norm_data.shape),max(norm_data.shape)-nnobs])
for i1,esto in enumerate([x[0] for x in est_mat]):
    idiocofmat[i1,:max(esto.shape)] = esto.reshape([1,max(esto.shape)])
idiostds = [x[2] for x in est_mat]



###################################################################################
####################     START BOOTSTRAP START     ################################
###################################################################################
# This is the finite AR(1) version of the common components bootstrap function
def pp_compboot_ar(intup):
    # Unpack the intup
    indexor = intup[0]
    compmat = intup[1]
    facmat = intup[2]
    idiomat = intup[3]
    KMH = intup[4]
    QQ = intup[5]
    qq_max = intup[6]
    rr_max = intup[7]
    bettax = intup[8]
    memory_adj = intup[9]
    var_resmat = intup[10]
    sfacs = intup[11]
    nnobs = intup[12]
    check_magnitude = intup[13]
    xfitted = intup[14]
    facs = intup[15]
    do_mcbs_comp = intup[16]
    regcheck_dim = intup[17]
    vnames = intup[18]
    check_redcovmat = intup[19]
    upperb = intup[20]
    lowerb = intup[21]
    check_betta = intup[22]
    redcovm = intup[23]
    redcovm_ind = intup[24]
    rotinc = intup[25]
    resmat_max = intup[26]
    idiocofmat = intup[27]
    idiostds = intup[28]

    # The success indicator for bootstrap
    succs = False
    
    # Initiate simulation by storing initial value
    compmat[:,0] =  xfitted[indexor[0],:]
    facmat[:,0] = facs.T[indexor[0],:]
    idiomat[:,0] = resmat_max[indexor[0],:]
    
    # Now loop over number of observations to compute successive values of simulation
    # each time drawing a new shock from the shuffled residual vectors
    # Use Monte Carlo or do conventional bootstrap? ==> Branched this out for performance
    if do_mcbs_comp:
        for kk in range(1,nnobs,1):
            sshock = numpy.random.normal(size=[1,qq_max])
            ssishock = numpy.random.normal(size=[1,min(idiomat.shape)],scale=idiostds)
            dshockf = numpy.dot(KMH,sshock.T).reshape([rr_max,1])
            newtermf = numpy.dot(bettax,facmat[:,kk-1]).reshape([rr_max,1])+dshockf.reshape([rr_max,1])
            facmat[:,kk] = newtermf.flatten()
            if kk < min(idiocofmat.shape):
                fittod = numpy.sum(numpy.tile(idiomat[:,kk-1],(min(idiocofmat.shape),1)).T*idiocofmat,axis=1).reshape([min(idiomat.shape),1])
                idiomat[:,kk] = (fittod+ssishock.T).T
            else:
                xx = idiomat[:,kk-1]
                for colo in range(min(idiocofmat.shape)-1):
                    xx = numpy.vstack((xx,idiomat[:,kk-(colo+2)]))
                fittod = numpy.sum(xx.T*idiocofmat,axis=1).reshape([min(idiomat.shape),1])
                idiomat[:,kk] = (fittod+ssishock.T).flatten()
    else:
        for kk in range(1,nnobs,1):
            sshock = sfacs[indexor[kk],:]
            ssishock = resmat_max[indexor[kk],:]
            dshockf = numpy.dot(KMH,sshock.T).reshape([rr_max,1])
            newtermf = numpy.dot(bettax,facmat[:,kk-1]).reshape([rr_max,1])+dshockf.reshape([rr_max,1])
            facmat[:,kk] = newtermf.flatten()
            if kk < min(idiocofmat.shape):
                fittod = numpy.sum(numpy.tile(idiomat[:,kk-1],(min(idiocofmat.shape),1)).T*idiocofmat,axis=1).reshape([min(idiomat.shape),1])
                idiomat[:,kk] = (fittod+ssishock.T).T
            else:
                xx = idiomat[:,kk-1]
                for colo in range(min(idiocofmat.shape)-1):
                    xx = numpy.vstack((xx,idiomat[:,kk-(colo+2)]))
                fittod = numpy.sum(xx.T*idiocofmat,axis=1).reshape([min(idiomat.shape),1])
                idiomat[:,kk] = (fittod+ssishock.T).flatten()        
    
    # Take principal components of simulated factors to orthogonalize them!
    # At this point facmat is nfacs x nnobs
    covfac = numpy.cov(facmat.reshape([min(facmat.shape),max(facmat.shape)]))
    Wf,Vf = numpy.linalg.eig(covfac)
    Wf = numpy.real(Wf)
    Vf = numpy.real(Vf)
    facmat = ((1.0/numpy.sqrt(max(facmat.shape)))*numpy.dot(Vf[:,:rr_max].T,facmat)).T # facmat is nnobs x nfacs
    stdfacs = numpy.std(facs,axis=1)
    stdsim = numpy.std(facmat,axis=0)
    adjustor = stdfacs/stdsim
    facmat = facmat*adjustor
    facmat = facmat.T
    
    # Generate the common components separately to adjust the standard deviations of the simulated factors    
    for kk in range(1,nnobs,1):
        facmat[:,kk] = (facmat[:,kk]*adjustor).flatten()
        compmat[:,kk] = (numpy.dot(QQ,facmat[:,kk])).flatten()
    
    # Check for stability of results computable from bootstrap pseudo-simulation
    facby = facmat.T[1:]
    facbx = facmat.T[:-1]
    bettaxb = numpy.dot(numpy.linalg.inv(numpy.dot(facbx.T,facbx)),numpy.dot(facbx.T,facby)).T
    '''
    print "Check estimated BETTA of pseudo-factors:\n"+str((bettaxb/bettax)[:regcheck_dim,:regcheck_dim]*100.0)
    print "Check reduced VCOV matrix of bootstrap:\n"+ str((numpy.cov(compmat[redcovm_ind,:])/redcovm)*100.00)
    bdiag = numpy.diag(bettaxb)
    bettaxb = copy.deepcopy(bettax)
    for diago in range(max(bdiag.shape)):
        bettaxb[diago,diago] = bdiag[diago]
    bxfit = numpy.dot(bettaxb,facs[:,-nnobs:-1])
    #facmat[:,1:] = bxfit + var_resmat[-(nnobs-1):,:].T
    facmat[:,1:] = bxfit + numpy.array(smemory).reshape([rr_max,len(smemory)])
    compmat[:,1:] = numpy.dot(QQ,facmat[:,1:])
    '''
    check = True
    check2 = True
    check3 = True    
    if check_betta:
        checkomat = (bettaxb[:regcheck_dim,:regcheck_dim]/numpy.abs(bettaxb[:regcheck_dim,:regcheck_dim])) ==\
            (bettax[:regcheck_dim,:regcheck_dim]/numpy.abs(bettax[:regcheck_dim,:regcheck_dim]))
        if not numpy.all(checkomat): check = False
    if check_magnitude:
        checkomat2 = numpy.abs((bettaxb/bettax))[:regcheck_dim,:regcheck_dim]*100.0
        if numpy.any(checkomat2 > upperb) or numpy.any(checkomat2 < lowerb): check2 = False
    if check_redcovmat:
        check3 = False
        checkomat3 = (numpy.cov(compmat[redcovm_ind,:])/abs(numpy.cov(compmat[redcovm_ind,:]))) == (redcovm/abs(redcovm))
        if numpy.all(checkomat3): check3 = True
    if check and check2 and check3:      
        print "ACCEPTED"
        succs = True
    else:
        print "DISCARDED"
        succs = False
    return [succs,facmat,idiomat,compmat]


# This is the infinite MA version of the common components bootstrap function
def pp_compboot_ma(intup):
    # Unpack the intup
    indexor = intup[0]
    compmat = intup[1]
    facmat = intup[2]
    idiomat = intup[3]
    KMH = intup[4]
    QQ = intup[5]
    qq_max = intup[6]
    rr_max = intup[7]
    bettax = intup[8]
    memory_adj = intup[9]
    var_resmat = intup[10]
    sfacs = intup[11]
    nnobs = intup[12]
    check_magnitude = intup[13]
    xfitted = intup[14]
    facs = intup[15]
    do_mcbs_comp = intup[16]
    regcheck_dim = intup[17]
    vnames = intup[18]
    check_redcovmat = intup[19]
    upperb = intup[20]
    lowerb = intup[21]
    check_betta = intup[22]
    redcovm = intup[23]
    redcovm_ind = intup[24]
    rotinc = intup[25]
    resmat_max = intup[26]
    idiocofmat = intup[27]
    idiostds = intup[28]   
    
    # The success indicator for bootstrap
    succs = False
    if do_mcbs_comp:
        # Fill up the shock memory with random draws up to size memory_adj
        sfmemory = copy.deepcopy(numpy.random.normal(size=[rr_max,1]))
        while max(sfmemory.shape) < memory_adj:
            dshockf = numpy.random.normal(size=[rr_max,1])
            sfmemory = numpy.hstack((dshockf,sfmemory))            
    else:
        # Draw the shocks from the shuffle-indexed residual vectors
        numpy.random.shuffle(indexor)
        sshock = sfacs[indexor[0],:]          
        sfmemory = copy.deepcopy(numpy.dot(KMH,sshock.T).reshape([rr_max,1]))
        while max(sfmemory.shape) < memory_adj:
            numpy.random.shuffle(indexor)
            sshock = sfacs[indexor[0],:]        
            dshockf = numpy.dot(KMH,sshock.T).reshape([rr_max,1])
            sfmemory = numpy.hstack((dshockf,sfmemory))
            pickind += 1
    # Remember the shocks used in simulation by storing them
    sfmemory = copy.deepcopy(dshockf)
    # Initiate simulation by storing initial value
    compmat[:,0] =  numpy.dot(QQ,dshockf).flatten()
    facmat[:,0] = dshockf.flatten()
    # Now loop over number of observations to compute successive values of simulation
    # each time drawing a new shock from the shuffled residual vectors
    for kk in range(1,nnobs-1,1):
        if do_mcbs_comp:
            sshock = numpy.random.normal(size=[1,qq_max])
            dshockf = numpy.dot(KMH,sshock.T).reshape([rr_max,1])
        else:
            sshock = sfacs[indexor[kk],:]
            dshockf = numpy.dot(KMH,sshock.T).reshape([rr_max,1])
        # Set up initial value for and compute recursively value of new term
        newterm = numpy.dot(QQ,dshockf).reshape([min(compmat.shape),1])
        newtermf = copy.deepcopy(dshockf).reshape([rr_max,1])
        for ll in range(min(kk,sfmemory.shape[1],memory_adj)):
            # for compmat
            newterm += numpy.dot(numpy.dot(QQ,numpy.mat(bettax)**(ll+1)),sfmemory[:,ll].reshape([rr_max,1]))
            # for facmat
            newtermf += numpy.dot((numpy.mat(bettax)**(ll+1)),sfmemory[:,ll].reshape([rr_max,1]))
        compmat[:,kk] =  newterm.flatten()
        facmat[:,kk] = newtermf.flatten()
        # Save most recently drawn shock into record memory.
        # Keep the memory of past shocks finite, i.e. <= memory_adj
        if max(sfmemory.shape) < memory_adj:
            sfmemory = numpy.hstack((dshockf,sfmemory))
        else:
            sfmemory = numpy.hstack((dshockf,sfmemory[:,:-1]))
    # Take principal components of simulated factors to orthogonalize them!
    Wf,Vf = numpy.linalg.eig(numpy.cov(facmat))
    Wf = numpy.real(Wf)
    Vf = numpy.real(Vf)
    facmat = ((1.0/numpy.sqrt(max(facmat.shape)))*numpy.dot(Vf[:,:rr_max].T,facmat)).T
    facmat = facmat.T
    # Generate the common components separately to adjust the standard deviations of the simulated factors
    stdfacs = numpy.std(facs,axis=1)
    stdsim = numpy.std(facmat,axis=1)
    adjustor = stdfacs/stdsim
    for faco in range(facmat.shape[0]):
        facmat[faco,:] = facmat[faco,:]*adjustor[faco]
    # Uncomment this and delete the last line before return if you want BETTA checking at BS stage
    # Check for stability of results computable from bootstrap pseudo-simulation
    facby = facmat.T[1:]
    facbx = facmat.T[:-1]
    bettaxb = numpy.dot(numpy.linalg.inv(numpy.dot(facbx.T,facbx)),numpy.dot(facbx.T,facby)).T
    print "Check estimated BETTA of pseudo-factors:\n"+str((bettaxb/bettax)[:regcheck_dim,:regcheck_dim]*100.0)
    #print "Check average standard error of bstrap: "+str(numpy.average(numpy.std(compmat[jj,:,:],axis=1)))
    #print "Check the VCOV matrix of bootstrap:\n"+ str((numpy.cov(compmat[jj,:,:])/numpy.cov(xfitted.T))[:4,:4]*100.00)
    check = (bettaxb[:regcheck_dim,:regcheck_dim]/numpy.abs(bettaxb[:regcheck_dim,:regcheck_dim])) ==\
        (bettax[:regcheck_dim,:regcheck_dim]/numpy.abs(bettax[:regcheck_dim,:regcheck_dim]))
    check2 = True
    if check_magnitude:
        checkomat = numpy.abs((bettaxb/bettax))[:regcheck_dim,:regcheck_dim]*100.0
        if numpy.any(checkomat > 500.0) or numpy.any(checkomat < 10.0): check2 = False
    if check.all() and check2:      
        print "ACCEPTED"
        succs = True
    else:
        print "DISCARDED"
        succs = False
    return [succs,facmat,compmat]


# Now compute the simulated idiosyncratic errors, using the infinite MA representation as well
def pp_idioboot_ar(intup):
    est_mat = intup[0]
    bdraw = intup[1]
    nnobs = intup[2]
    index_store = intup[3]
    idiomat = intup[4]
    memory_adj2 = intup[5]
    do_mcbs_idio = intup[6]
    vname = intup[7]
    resmat = intup[8]
    bsize = max(est_mat[0].shape)
    bbetta = numpy.identity(bsize)
    bbetta = numpy.vstack((est_mat[0].reshape([1,bsize]),bbetta))[:-1,:]
    stdo = est_mat[2]
    # Make sure the residual matrix has the right dimension, by filling up first couple of values if needed
    resumat = copy.deepcopy(est_mat[-1])
    while max(resumat.shape) < nnobs:
        resumat = numpy.vstack((numpy.random.normal(scale=stdo,size=(1,1)).reshape([1,1]),resumat))
    # Start the bootstrap loop
    for jj in range(bdraw):
        # Use the same index as in the boostrap runs made for the factor model
        indexor = index_store[jj]
        # Start the AR iteration, but make sure that the initial idiomat is filled up to size bsize
        idiomat[jj,0] = resmat[indexor[0]]
        while len(idiomat[jj]) < bsize:
            idiomat[jj] = numpy.vstack((idiomat[jj]),numpy.zeros([1,1]))
        if jj == 0: print "Now pseudo-simulating idiosyncratic error for series: "+vname
        print "Idiosyncratic error boostrap run #:"+str(jj+1)+'/'+str(bdraw)
        for kk in range(1,nnobs,1):
            if do_mcbs_idio:
                dshock = numpy.random.normal(scale=stdo,size=[1,1])
            else:
                dshock = resumat[indexor[kk]].reshape([1,1])
            newfit = numpy.dot(bbetta,idiomat[jj][:bsize]).reshape([1,bsize])
            newterm = newfit[0,0]+dshock
            idiomat[jj] = numpy.vstack((newterm,idiomat[jj][:-1].reshape([max(idiomat.shape)-1,1]))).flatten()
    return idiomat


# Now compute the simulated idiosyncratic errors, using the infinite MA representation as well
def pp_idioboot_ma(intup):
    est_mat = intup[0]
    bdraw = intup[1]
    nnobs = intup[2]
    index_store = intup[3]
    idiomat = intup[4]
    memory_adj2 = intup[5]
    do_mcbs_idio = intup[6]
    vname = intup[6]
    bsize = max(est_mat[0].shape)
    bbetta = numpy.identity(bsize)
    bbetta = numpy.vstack((est_mat[0].reshape([1,bsize]),bbetta))[:-1,:]
    stdo = est_mat[2]
    # Make sure the residual matrix has the right dimension, by filling up first couple of values if needed
    resumat = copy.deepcopy(est_mat[-1])
    while max(resumat.shape) < nnobs:
        resumat = numpy.vstack((numpy.random.normal(scale=stdo,size=(1,1)).reshape([1,1]),resumat))
    # Start the bootstrap loop
    for jj in range(bdraw):
        # Use the same index as in the boostrap runs made for the factor model
        indexor = index_store[jj]
        # Start the MA iteration by initializing with first shock draw
        idiomat[jj,0] = resumat[0,0]
        smemory = copy.deepcopy(resumat[0,0]).reshape([1,1])
        if jj == 0: print "Now pseudo-simulating idiosyncratic error for series: "+vname
        print "Idiosyncratic error boostrap run #:"+str(jj+1)+'/'+str(bdraw)
        for kk in range(1,nnobs-1,1):
            dshock = resumat[indexor[kk],0].reshape([1,1])
            while max(smemory.shape) < bsize:
                smemory = numpy.vstack((smemory,numpy.zeros([1,1])))
            newterm = copy.deepcopy(dshock)
            #print "Using a total of <<"+str(range(min(kk,(max(smemory.shape)-bsize)+1))[-1])+">> terms..."
            for ll in range(min(kk,(max(smemory.shape)-bsize)+1,memory_adj2)):
                newterm += numpy.dot(numpy.mat(bbetta)**(ll+1),smemory[ll:ll+bsize,:])[0,:]
            idiomat[jj,kk] =  newterm.flatten()
            # Save most recently drawn shock into record memory.
            smemory = numpy.vstack((dshock,smemory))
    return idiomat

    
def gen_bootstraps(intup,size=bdraw,docomp=True,doidio=do_idio_boot,restandardize=True,use_comp_ma=use_comp_ma,use_idio_ma=use_idio_ma):
    # Unpack what is needed from intup
    nnobs = intup[0]
    resmat_max = intup[1]
    bettax = intup[2]
    KK = intup[3]
    MM = intup[4]
    HH = intup[5]
    QQ = intup[6]
    sfacs = intup[7]
    qq_max = intup[8]
    rr_max = intup[9]
    memory_adj = intup[10]
    memory_adj2 = intup[11]
    var_resmat = intup[12]
    check_magnitude = intup[13]
    xfitted = intup[14]
    facs = intup[15]
    do_mcbs_comp = intup[16]
    do_mcbs_idio = intup[17]
    regcheck_dim = intup[18]
    vnames = intup[19]
    check_redcovmat = intup[20]
    upperb = intup[21]
    lowerb = intup[22]
    check_betta = intup[23]
    rotinc = intup[24]
    idiocofmat = intup[25]
    idiostds = intup[26]

    # Generate reduced covmat matrix and it's index for later checking
    redcovm = numpy.vstack((xfitted[:,vnames.index('CPIAUCSL')],\
                            xfitted[:,vnames.index('CPIUFDNS')],\
                            xfitted[:,vnames.index('FEDFUNDS')],\
                            xfitted[:,vnames.index('IC4WSA')],\
                            xfitted[:,vnames.index('IPDCONGD')],\
                            xfitted[:,vnames.index('UNCERT')]))
    redcovm = numpy.cov(redcovm)
    redcovm_ind = [vnames.index('CPIAUCSL'),vnames.index('CPIUFDNS'),\
                   vnames.index('FEDFUNDS'),vnames.index('IC4WSA'),\
                   vnames.index('IPDCONGD'),vnames.index('UNCERT')]    
    
    # Now do the parallel bootstrap for idiosyncratic shocks and common components
    compmat = numpy.zeros([min(resmat_max.shape),nnobs]) # only for the common components
    facmat = numpy.zeros([min(bettax.shape),nnobs]) # only for the factor series
    idiomat = numpy.zeros([min(resmat_max.shape),nnobs]) # only for the idiosyncratic errors
    
    KMH = numpy.dot(numpy.dot(KK,MM),HH) # Define this composite matrix now for later use
    # Re-define the sfacs before inputting into boostrap procedure
    stdf = numpy.std(sfacs,axis=0)
    for colo in xrange(sfacs.shape[0]):
        sfacs[colo] = (sfacs[colo]/stdf).flatten()
    index_store = []
    barray = []
    barray_resu = []
    totcount=0
    while len(barray_resu) < size:
        # Shuffle the index vector for each new bootstrap run jj
        curr_store = []
        for elem in xrange(job_server.get_ncpus()):
            indexor = range(nnobs)
            numpy.random.shuffle(indexor)
            curr_store.append(indexor)
            index_store.append(indexor)
        # Set up the boostraps
        if use_comp_ma:
            inputs = ((compmat,facmat,idiomat,KMH,QQ,qq_max,rr_max,bettax,memory_adj,var_resmat,sfacs,nnobs,check_magnitude,xfitted,facs,do_mcbs_comp,regcheck_dim,vnames,check_redcovmat,upperb,lowerb,check_betta,redcovm,redcovm_ind,rotinc,resmat_max,idiocofmat,idiostds),)*job_server.get_ncpus()
            barray_jobs = [job_server.submit(pp_compboot_ma,((curr_store[i1],)+inputo,),\
                                             modules=("copy","numpy"),depfuncs=(rotmat3d,)) for i1,inputo in enumerate(inputs)]
        else:
            inputs = ((compmat,facmat,idiomat,KMH,QQ,qq_max,rr_max,bettax,memory_adj,var_resmat,sfacs,nnobs,check_magnitude,xfitted,facs,do_mcbs_comp,regcheck_dim,vnames,check_redcovmat,upperb,lowerb,check_betta,redcovm,redcovm_ind,rotinc,resmat_max,idiocofmat,idiostds),)*job_server.get_ncpus()
            barray_jobs = [job_server.submit(pp_compboot_ar,((curr_store[i1],)+inputo,),\
                                             modules=("copy","numpy"),depfuncs=(rotmat3d,)) for i1,inputo in enumerate(inputs)]                
        barray = [x() for x in barray_jobs]
        totcount += len(barray)
        print "Total COMPUTED: "+str(totcount)
        barray_resu += [x[1:] for x in barray if x[0]]
        print "Total ACCEPTED: "+str(len(barray_resu))
    facmat = numpy.array([x[0] for x in barray_resu])[:size]
    idiomat = numpy.array([x[1] for x in barray_resu])[:size]
    compmat = numpy.array([x[2] for x in barray_resu])[:size]            
        
    # Add them together
    if do_idio_boot:
        allmat = compmat + idiomat
    else:
        allmat = compmat
    
    if restandardize:    
        # Re-standardize the simulated data to be ~N(0,1)
        for elem in xrange(allmat.shape[0]):
            allmat[elem] = (allmat[elem].T/numpy.std(allmat[elem],axis=1)).T
            compmat[elem] = (compmat[elem].T/numpy.std(compmat[elem],axis=1)).T    
        
    return allmat,facmat,compmat,idiomat



# Prepare inputs and call the bootrap-generating function
intup = []
intup.append(nnobs)
intup.append(resmat_max)
intup.append(bettax)
intup.append(KK)
intup.append(MM)
intup.append(HH)
intup.append(QQ)
intup.append(sfacs)
intup.append(qq_max)
intup.append(rr_max)
intup.append(memory_adj)
intup.append(memory_adj2)
intup.append(var_resmat)
intup.append(check_magnitude)
intup.append(xfitted)
intup.append(facs)
intup.append(do_mcbs_comp)
intup.append(do_mcbs_idio)
intup.append(regcheck_dim)
intup.append(vnames)
intup.append(check_redcovmat)
intup.append(upperb)
intup.append(lowerb)
intup.append(check_betta)
intup.append(rotinc)
intup.append(idiocofmat)
intup.append(idiostds)
effbdraw = bdraw*bblock_ratio+((bdraw*bblock_ratio)%job_server.get_ncpus())
allmat,facmat,compmat,idiomat = gen_bootstraps(intup,size=effbdraw,docomp=True,
                                        doidio=do_idio_boot,restandardize=True,
                                        use_comp_ma=use_comp_ma,use_idio_ma=use_idio_ma)


# Plot some simulated data and save for visual inspection
if do_plots:
    if 'compmat' in dir():
        # Graph the sample pseudo-generated common components
        for col in range(min(resmat_max.shape)):
            fig1 = plt.figure()
            ax1 = fig1.add_subplot(111)
            if gridopt: ax1.grid()
            timex = [str(x)+'-01' for x in dator_final[-len(trans_data[:,col]):]][-nnobs:]
            timex = [dt.datetime(*[int(x) for x in x.split('-')]) for x in timex]
            ax1.plot(timex, compmat[0,col,:], color='black')
            for label in ax1.get_xticklabels():
                label.set_rotation(55)        
            if plotrec:
                for reco in rdates:
                    ylim_0 = ax1.get_ylim()[0]
                    ylim_1 = ax1.get_ylim()[1]
                    plt.fill([reco[0],reco[1],reco[1],reco[0]],
                             [ylim_0,ylim_0,ylim_1,ylim_1],
                             reccol, alpha=rectrans, edgecolor=reccol) 
            ax1.set_title(r'Pseudo-generated common component for variable: '+vnames[col],fontsize=glopt['title_fs'])
            ax1.set_rasterization_zorder(1)            
            fig1.savefig('../graphs/'+modname+'/'+'fitted/bsample/'+vnames[col]+'.'+graph_options['ftype'],bbox_inches='tight',dpi=graph_options['dpi'])
            plt.close(fig1)
        
    
    if 'idiomat' in dir():
        # Graph the sample pseudo-generated idiosyncratic shocks
        for col in range(min(resmat_max.shape)):
            fig1 = plt.figure()
            ax1 = fig1.add_subplot(111)
            if gridopt: ax1.grid()
            timex = [str(x)+'-01' for x in dator_final[-len(trans_data[:,col]):]][-nnobs:]
            timex = [dt.datetime(*[int(x) for x in x.split('-')]) for x in timex]
            ax1.plot(timex, idiomat[0,col,:], color='black')
            for label in ax1.get_xticklabels():
                label.set_rotation(55)        
            if plotrec:
                for reco in rdates:
                    ylim_0 = ax1.get_ylim()[0]
                    ylim_1 = ax1.get_ylim()[1]
                    plt.fill([reco[0],reco[1],reco[1],reco[0]],
                             [ylim_0,ylim_0,ylim_1,ylim_1],
                             reccol, alpha=rectrans, edgecolor=reccol) 
            ax1.set_title(r'Pseudo-generated idiosyncratic shock for variable: '+vnames[col],fontsize=glopt['title_fs'])
            ax1.set_rasterization_zorder(1)            
            fig1.savefig('../graphs/'+modname+'/'+'idio_shocks/bsample/'+vnames[col]+'.'+graph_options['ftype'],bbox_inches='tight',dpi=graph_options['dpi'])
            plt.close(fig1)
        
        
    if 'facmat' in dir():
        # Graph the sample pseudo-generated factors
        for col in range(min(bettax.shape)):
            fig1 = plt.figure()
            ax1 = fig1.add_subplot(111)
            if gridopt: ax1.grid()
            timex = [str(x)+'-01' for x in dator_final[-len(trans_data[:,col]):]][-nnobs:]
            timex = [dt.datetime(*[int(x) for x in x.split('-')]) for x in timex]
            ax1.plot(timex, facmat[0,col,:], color='black')
            for label in ax1.get_xticklabels():
                label.set_rotation(55)        
            if plotrec:
                for reco in rdates:
                    ylim_0 = ax1.get_ylim()[0]
                    ylim_1 = ax1.get_ylim()[1]
                    plt.fill([reco[0],reco[1],reco[1],reco[0]],
                             [ylim_0,ylim_0,ylim_1,ylim_1],
                             reccol, alpha=rectrans, edgecolor=reccol) 
            ax1.set_title(r'Pseudo-generated sample for factor '+str(col+1),fontsize=glopt['title_fs'])
            ax1.set_rasterization_zorder(1)            
            fig1.savefig('../graphs/'+modname+'/'+'factors/bsample/'+'factor_'+str(col+1)+'.'+graph_options['ftype'],bbox_inches='tight',dpi=graph_options['dpi'])
            plt.close(fig1)
        



# Now boostrap the IRF confidence intervals
irfli_boot = []
facsli_boot = []
bettaxli_boot = []
dblock = 0
jj = 0
while len(irfli_boot) < bdraw:
    print "Now generating pseudo-IRF: "+str((effbdraw*dblock)+(jj+1))
    data_boot = copy.deepcopy(allmat[jj].T)
    W_boot,V_boot = scipy.linalg.eig(numpy.cov(data_boot.T))
    W_boot = numpy.real(W_boot)
    V_boot = numpy.real(V_boot)
    # May have to adjust some factor by changing signs
    W_boot[0] = W_boot[0]*(-1.0)
    for i in range(V_boot.shape[0]):
        V_boot[i,0] = V_boot[i,0]*(-1.0)    
  

    facs_boot = (1.0/numpy.sqrt(data_boot.shape[0]))*numpy.dot(V_boot[:,:rr_max].T,data_boot.T)
    facsli_boot.append(facs_boot)
    xfitted_boot = numpy.dot(numpy.dot(V_boot[:,:rr_max],V_boot[:,:rr_max].T),data_boot.T).T
    resmat_boot = data_boot - xfitted_boot
    
    # Estimate the VAR(1) in the static factors
    facs_y_boot = copy.deepcopy(facs_boot.T[1:,:])
    facs_1_boot = copy.deepcopy(facs_boot.T[:-1,:])
    yxcov_boot = (1.0/float(max(data_boot[1:].shape)))*(numpy.dot(data_boot[1:].T,data_boot[:-1]))
    xxcov_boot = (1.0/float(max(data_boot.shape)))*(numpy.dot(data_boot.T,data_boot))
    DeltaN_boot = numpy.dot(numpy.dot(V_boot[:,:rr_max].T,xxcov_boot),V_boot[:,:rr_max])
    WCW_boot = numpy.dot(numpy.dot(V_boot[:,:rr_max].T,yxcov_boot),V_boot[:,:rr_max])
    bettax_boot = numpy.dot(WCW_boot,numpy.linalg.inv(DeltaN_boot))
    var_resmat_boot = facs_y_boot - numpy.dot(bettax_boot,facs_1_boot.T).T

    # Extract q principal components from residuals to get the q shocks
    Wx_boot,Vx_boot = scipy.linalg.eig(numpy.cov(var_resmat_boot.T))
    Wx_boot = numpy.real(Wx_boot)
    Vx_boot = numpy.real(Vx_boot)
    MM_boot = numpy.sqrt(Wx_boot[:qq_max].T)*numpy.identity(qq_max)
    KK_boot = Vx_boot[:,:qq_max]
    k_boot = max(KK_boot.shape)
    xcov_boot = numpy.cov(data_boot.T)
    QQ_boot = (1/numpy.sqrt(k_boot))*numpy.dot(xcov_boot,V_boot[:,:rr_max])
    HH_boot = copy.deepcopy(HH)
    KMHb = numpy.dot(KK_boot,numpy.dot(MM_boot,HH_boot))
    '''
    # Check for success of estimated bettax
    print "Check estimated BETTA of pseudo-factors:\n"+str((bettax_boot/bettax)[:regcheck_dim,:regcheck_dim]*100.0)
    check = (bettax_boot[:regcheck_dim,:regcheck_dim]/numpy.abs(bettax_boot[:regcheck_dim,:regcheck_dim])) ==\
        (bettax[:regcheck_dim,:regcheck_dim]/numpy.abs(bettax[:regcheck_dim,:regcheck_dim]))
    check2 = True
    check3 = True
    checkomat2 = [True,]*QQ_boot.shape[0]
    if check_magnitude:
        checkomat = numpy.abs((bettax_boot/bettax))[:regcheck_dim,:regcheck_dim]*100.0
        if numpy.any(checkomat > 500.0) or numpy.any(checkomat < 10.0): check2 = False
    # At the moment check only the sign of the initial impact of the last shock
    if use_sign_filter:
        impact = numpy.dot(QQ_boot,numpy.dot(numpy.dot(numpy.dot(numpy.identity(rr_max),KK_boot),MM_boot),HH_boot))
        impact_sign = impact[:,-1]/abs(impact[:,-1])
        checkomat2 = impact_sign == msigns[:,-1]
        if not numpy.all(checkomat2): check3 = False
    if check.all() and check2 and check3:      
        print "IRF ACCEPTED"
        succs = True
    else:
        print "IRF DISCARDED"+(not check3)*"(SIGN CHECK FAILED #"+(not check3)*str(sum([1 if x==False else 0 for x in checkomat2]))+")"
        succs = False
    '''
    succs = True
    jj += 1
    # Continue only if the bettax estimate is satisfactory
    if succs:
        bettaxli_boot.append(bettax_boot)
        
        # recursively compute Phi matrices, but using the first-order companion matrix
        p_boot = 1
        phis_comp_boot = numpy.zeros((maxphi+1,k_boot,qq_max))
        phis_comp_boot[0] = KMHb
        for i in xrange(1, maxphi + 1):
            phis_comp_boot[i] = numpy.dot(bettax_boot,phis_comp_boot[i-1])
        irfs_boot = numpy.array([numpy.dot(QQ,x) for x in phis_comp_boot])
        irfli_boot.append(irfs_boot)
    # Once the available bootstrap data is exhausted we need to create new pseudo data
    if jj >= (allmat.shape[0]+1):
        dblock += 1
        # Bootstrap data is not enough, need to generate more!
        # Prepare inputs and call the bootrap-generating function
        print "IRF CI procedure now generating data block: "+str(dblock)
        intup = []
        intup.append(nnobs)
        intup.append(resmat_max)
        intup.append(bettax)
        intup.append(KK)
        intup.append(MM)
        intup.append(HH)
        intup.append(QQ)
        intup.append(sfacs)
        intup.append(qq_max)
        intup.append(rr_max)
        intup.append(memory_adj)
        intup.append(memory_adj2)
        intup.append(var_resmat)
        intup.append(check_magnitude)
        intup.append(xfitted)
        intup.append(facs)
        intup.append(do_mcbs_comp)
        intup.append(do_mcbs_idio)
        intup.append(regcheck_dim)
        intup.append(vnames)
        intup.append(check_redcovmat)
        intup.append(upperb)
        intup.append(lowerb)
        intup.append(check_betta)
        intup.append(rotinc)
        intup.append(idiocofmat)
        intup.append(idiostds)        
        effbdraw = bdraw*bblock_ratio+((bdraw*bblock_ratio)%job_server.get_ncpus())       
        allmat,facmat,compmat,idiomat = gen_bootstraps(intup,size=effbdraw,docomp=True,doidio=do_idio_boot,restandardize=True,
                                                       use_comp_ma=use_comp_ma,use_idio_ma=use_idio_ma)
        if not do_idio_boot:
            del idiomat
        # Reset jj back to 0 to iterate through new data block
        jj = 0
    print "Successful IRFs: "+str(len(irfli_boot))
        

irfli_boot = numpy.array(irfli_boot)
bettaxli_boot = numpy.array(bettaxli_boot)
facsli_boot = numpy.array(facsli_boot)

# Filter the IRFli_boot using msigns and mderiv
irfdic_boot = {}
for shocko in range(irfli_boot.shape[-1]):
    for varo in range(irfli_boot.shape[-2]):
        if vnames[varo] not in irfdic_boot.keys():
            irfdic_boot[vnames[varo]] = {}
            irfdic_boot[vnames[varo]]['1'] = numpy.zeros([1,irfli_boot.shape[1]])
            irfdic_boot[vnames[varo]]['2'] = numpy.zeros([1,irfli_boot.shape[1]])
            irfdic_boot[vnames[varo]]['3'] = numpy.zeros([1,irfli_boot.shape[1]])
            irfdic_boot[vnames[varo]]['4'] = numpy.zeros([1,irfli_boot.shape[1]])
        for bso in range(irfli_boot.shape[0]):
            # Compute a regression which can be used to select suitable IRFs
            xxf = numpy.hstack((numpy.ones([max(irfli_boot[bso,:,varo,shocko].shape),1]),\
                                irfli_boot[bso,:,varo,shocko].reshape([max(irfli_boot[bso,:,varo,shocko].shape),1])))
            yyf = irfs[:,varo,shocko].reshape([max(irfs[:,varo,shocko].shape),1])
            bettaf = numpy.dot(numpy.linalg.inv(numpy.dot(xxf[:R2ind_crit].T,xxf[:R2ind_crit])),\
                               numpy.dot(xxf[:R2ind_crit].T,yyf[:R2ind_crit]))
            yyff = numpy.dot(bettaf.T,xxf.T).T
            RSS = numpy.sum((yyf - yyff)**2)
            TSS = numpy.sum((yyf - numpy.average(yyf))**2)
            R2 = (1.0-RSS/TSS)*100.0

            if R2 > R2_crit and irfli_boot[bso,0,varo,shocko]/abs(irfli_boot[bso,0,varo,shocko]) == msigns[varo,shocko] and\
               (irfli_boot[bso,offset1,varo,shocko]-irfli_boot[bso,0,varo,shocko])/\
               abs(irfli_boot[bso,offset1,varo,shocko]-irfli_boot[bso,0,varo,shocko]) == mderiv[varo,shocko,0] and\
               (irfli_boot[bso,offset1+offset2,varo,shocko]-irfli_boot[bso,offset1,varo,shocko])/\
               abs(irfli_boot[bso,offset1+offset2,varo,shocko]-irfli_boot[bso,offset1,varo,shocko]) == mderiv[varo,shocko,1] and\
                bettaf.flatten()[1] > 0.0:
                irfdic_boot[vnames[varo]][str(shocko+1)] =\
                    numpy.vstack((irfdic_boot[vnames[varo]][str(shocko+1)],\
                                  irfli_boot[bso,:,varo,shocko].reshape([1,irfli_boot.shape[1]])))

# Slice off the top row with zeros
for varo in range(irfli_boot.shape[-2]):
    keyos = irfdic_boot[vnames[0]].keys()
    for keyo in keyos:
        irfdic_boot[vnames[varo]][keyo] = copy.deepcopy(irfdic_boot[vnames[varo]][keyo][1:,:])

'''
if append:
    # First load the existing data
    # Load data from disk
    output = open('../data/irfli.pickle','r')
    irfli_old = pickle.load(output)
    output.close()
    output = open('../data/irfdic.pickle','r')
    irfdic_old = pickle.load(output)
    output.close()
    
    # Now append new to old before saving
    irfli_boot = numpy.vstack((irfli_boot,irfli_old))
    for varo in irfdic_boot.keys():
        for shocko in range(irfli_boot.shape[-1]):
            irfdic_boot[varo][str(shocko+1)] = numpy.vstack((irfdic_boot[varo][str(shocko+1)],\
                                                               irfdic_old[varo][str(shocko+1)]))

    # Pickle and save data (IRFs) on disk
    output = open('../data/irfli.pickle','wb')
    pickle.dump(irfli_boot,output)
    output.close()
    output = open('../data/irfdic.pickle','wb')
    pickle.dump(irfdic_boot,output)
    output.close()
else:
    # Pickle and save data (IRFs) on disk
    output = open('../data/irfli.pickle','wb')
    pickle.dump(irfli_boot,output)
    output.close()
    output = open('../data/irfdic.pickle','wb')
    pickle.dump(irfdic_boot,output)
    output.close()
'''

# Plot some individual IRFs and FEVDs
irf_options = modconfig['graph_options']['irfs']
outer_colour = irf_options['outer_colour']
inner_colour = irf_options['inner_colour']
line_colour = irf_options['line_colour']
glopt = modconfig['graph_options']['labels']
gridopt = modconfig['graph_options']['grid'] 
gridopt = modconfig['graph_options']['grid']
glopt = modconfig['graph_options']['labels']
shocko = 3
namo = 'UNCERT'
varo = vnames.index(namo)
fig3 = plt.figure()
ax3 = fig3.add_subplot(111)
ax3.grid()
lower_outer = scipy.stats.scoreatpercentile(irfdic_boot[vnames[varo]][str(shocko+1)],per=5.0,axis=0)
lower_inner = scipy.stats.scoreatpercentile(irfdic_boot[vnames[varo]][str(shocko+1)],per=(34.0/2.0),axis=0)
upper_inner = scipy.stats.scoreatpercentile(irfdic_boot[vnames[varo]][str(shocko+1)],per=100.0-(34.0/2.0),axis=0)
upper_outer = scipy.stats.scoreatpercentile(irfdic_boot[vnames[varo]][str(shocko+1)],per=95.0,axis=0)
confint = [lower_outer,lower_inner,upper_inner,upper_outer]
pswitch = False
if vardic[vnames[varo]] in [7,8,20,22,24]:
    ax3.plot(numpy.average(irfdic_boot[vnames[varo]][str(shocko+1)].T*trans_dic[vnames[varo]]['std']*100.0,axis=1), color='black', linewidth=2.0)
    ax3.fill_between([xx for xx in range(0,irfli_boot.shape[1],1)],confint[0].flatten()*trans_dic[vnames[varo]]['std']*100.0,confint[1].flatten()*trans_dic[vnames[varo]]['std']*100.0, facecolor=inner_colour, edgecolor=inner_colour)
    ax3.fill_between([xx for xx in range(0,irfli_boot.shape[1],1)],confint[1].flatten()*trans_dic[vnames[varo]]['std']*100.0,confint[2].flatten()*trans_dic[vnames[varo]]['std']*100.0, facecolor=outer_colour, edgecolor=outer_colour)
    ax3.fill_between([xx for xx in range(0,irfli_boot.shape[1],1)],confint[2].flatten()*trans_dic[vnames[varo]]['std']*100.0,confint[3].flatten()*trans_dic[vnames[varo]]['std']*100.0, facecolor=inner_colour, edgecolor=inner_colour)
    pswitch = True
else:
    ax3.plot(numpy.average(irfdic_boot[vnames[varo]][str(shocko+1)].T*trans_dic[vnames[varo]]['std'],axis=1), color='black', linewidth=2.0)
    ax3.fill_between([xx for xx in range(0,irfli_boot.shape[1],1)],confint[0].flatten()*trans_dic[vnames[varo]]['std'],confint[1].flatten()*trans_dic[vnames[varo]]['std'], facecolor=inner_colour, edgecolor=inner_colour)
    ax3.fill_between([xx for xx in range(0,irfli_boot.shape[1],1)],confint[1].flatten()*trans_dic[vnames[varo]]['std'],confint[2].flatten()*trans_dic[vnames[varo]]['std'], facecolor=outer_colour, edgecolor=outer_colour)
    ax3.fill_between([xx for xx in range(0,irfli_boot.shape[1],1)],confint[2].flatten()*trans_dic[vnames[varo]]['std'],confint[3].flatten()*trans_dic[vnames[varo]]['std'], facecolor=inner_colour, edgecolor=inner_colour)
ax3.set_xlabel(r'Time periods after shock',fontsize=glopt['xlabel_fs'])
ax3.set_ylabel(r'Response'+pswitch*' in percentages',fontsize=glopt['ylabel_fs'])
ax3.set_xlim([0,60])
ax3.set_rasterization_zorder(1)            
fig3.savefig('../graphs/'+modname+'/irfs/'+vnames[varo]+'_'+str(shocko+1)+'.'+graph_options['ftype'],bbox_inches='tight',dpi=graph_options['dpi'])
plt.close(fig3)
        

# Plot the impulse response functions and their confidence intervals
irf_options = modconfig['graph_options']['irfs']
outer_colour = irf_options['outer_colour']
inner_colour = irf_options['inner_colour']
line_colour = irf_options['line_colour']
glopt = modconfig['graph_options']['labels']
gridopt = modconfig['graph_options']['grid'] 
gridopt = modconfig['graph_options']['grid']
glopt = modconfig['graph_options']['labels']
for shocko in xrange(qq_max):
    for varo in xrange(max(QQ.shape)):
        plt.clf()
        plt.cla()
        title = r'Response of variable: '+vnames[varo]+' to shock '+str(shocko+1)
        fig1 = plt.figure()
        ax1 = fig1.add_subplot(111)
        if gridopt: ax1.grid()
        pswitch = False
        if vardic[vnames[varo]] in [7,8,20,22,24]:
            ax1.plot(irfli_boot[:,:,varo,shocko].T*trans_dic[vnames[varo]]['std']*100.0, color='black')
            pswitch = True
        else:
            ax1.plot(irfli_boot[:,:,varo,shocko].T*trans_dic[vnames[varo]]['std'], color='black')
        ax1.set_title(title,fontsize=glopt['title_fs'])
        ax1.set_xlabel(r'Time periods after shock',fontsize=glopt['xlabel_fs'])
        ax1.set_ylabel(r'Response'+pswitch*' in percentages',fontsize=glopt['ylabel_fs'])
        ax1.set_xlim([0,60])
        ax1.set_rasterization_zorder(1)        
        fig1.savefig('../graphs/'+modname+'/irfs/'+'shock_'+str(shocko+1)+'/'+vnames[varo]+'_'+str(shocko+1)+'.'+graph_options['ftype'],bbox_inches='tight',dpi=graph_options['dpi'])
        plt.close(fig1)
        
        if irfdic_boot[vnames[varo]][str(shocko+1)].tolist() != []:
            title = r'Response of variable: '+vnames[varo]+' to shock '+str(shocko+1)
            fig3 = plt.figure()
            ax3 = fig3.add_subplot(111)
            if gridopt:
                ax3.grid()
            lower_outer = scipy.stats.scoreatpercentile(irfdic_boot[vnames[varo]][str(shocko+1)],per=5.0,axis=0)
            lower_inner = scipy.stats.scoreatpercentile(irfdic_boot[vnames[varo]][str(shocko+1)],per=(34.0/2.0),axis=0)
            upper_inner = scipy.stats.scoreatpercentile(irfdic_boot[vnames[varo]][str(shocko+1)],per=100.0-(34.0/2.0),axis=0)
            upper_outer = scipy.stats.scoreatpercentile(irfdic_boot[vnames[varo]][str(shocko+1)],per=95.0,axis=0)
            confint = [lower_outer,lower_inner,upper_inner,upper_outer]
            pswitch = False
            if vardic[vnames[varo]] in [7,8,20,22,24]:
                ax3.plot(numpy.average(irfdic_boot[vnames[varo]][str(shocko+1)].T*trans_dic[vnames[varo]]['std']*100.0,axis=1), color='black', linewidth=2.0)
                ax3.fill_between([xx for xx in range(0,irfli_boot.shape[1],1)],confint[0].flatten()*trans_dic[vnames[varo]]['std']*100.0,confint[1].flatten()*trans_dic[vnames[varo]]['std']*100.0, facecolor=inner_colour, edgecolor=inner_colour)
                ax3.fill_between([xx for xx in range(0,irfli_boot.shape[1],1)],confint[1].flatten()*trans_dic[vnames[varo]]['std']*100.0,confint[2].flatten()*trans_dic[vnames[varo]]['std']*100.0, facecolor=outer_colour, edgecolor=outer_colour)
                ax3.fill_between([xx for xx in range(0,irfli_boot.shape[1],1)],confint[2].flatten()*trans_dic[vnames[varo]]['std']*100.0,confint[3].flatten()*trans_dic[vnames[varo]]['std']*100.0, facecolor=inner_colour, edgecolor=inner_colour)
                pswitch = True
            else:
                ax3.plot(numpy.average(irfdic_boot[vnames[varo]][str(shocko+1)].T*trans_dic[vnames[varo]]['std'],axis=1), color='black', linewidth=2.0)
                ax3.fill_between([xx for xx in range(0,irfli_boot.shape[1],1)],confint[0].flatten()*trans_dic[vnames[varo]]['std'],confint[1].flatten()*trans_dic[vnames[varo]]['std'], facecolor=inner_colour, edgecolor=inner_colour)
                ax3.fill_between([xx for xx in range(0,irfli_boot.shape[1],1)],confint[1].flatten()*trans_dic[vnames[varo]]['std'],confint[2].flatten()*trans_dic[vnames[varo]]['std'], facecolor=outer_colour, edgecolor=outer_colour)
                ax3.fill_between([xx for xx in range(0,irfli_boot.shape[1],1)],confint[2].flatten()*trans_dic[vnames[varo]]['std'],confint[3].flatten()*trans_dic[vnames[varo]]['std'], facecolor=inner_colour, edgecolor=inner_colour)
            ax3.set_title(title,fontsize=glopt['title_fs'])
            ax3.set_xlabel(r'Time periods after shock',fontsize=glopt['xlabel_fs'])
            ax3.set_ylabel(r'Response'+pswitch*' in percentages',fontsize=glopt['ylabel_fs'])
            '''
            ax3.text(39.0,ax3.get_ylim()[1]-0.2*ax3.get_ylim()[1],\
                     str(round((float(irfdic_boot[vnames[varo]][str(shocko+1)].shape[0])/float(irfli_boot.shape[0]))*100.0,4))+'\% '+\
                     str([round(x,2) for x in QQ[varo,:qq_max]]))
            '''
            ax3.set_xlim([0,60])
            ax3.set_rasterization_zorder(1)            
            fig3.savefig('../graphs/'+modname+'/irfs/'+'pshock_'+str(shocko+1)+'/'+vnames[varo]+'_'+str(shocko+1)+'.'+graph_options['ftype'],bbox_inches='tight',dpi=graph_options['dpi'])
            plt.close(fig3)

            fig2 = plt.figure()
            ax2 = fig2.add_subplot(111)
            if gridopt: ax2.grid()
            pswitch = False
            if vardic[vnames[varo]] in [7,8,20,22,24]:
                ax2.plot(irfdic_boot[vnames[varo]][str(shocko+1)].T*trans_dic[vnames[varo]]['std']*100.0, color='black')
                pswitch = True
            else:
                ax2.plot(irfdic_boot[vnames[varo]][str(shocko+1)].T*trans_dic[vnames[varo]]['std'], color='black')
            ax2.set_title(title,fontsize=glopt['title_fs'])
            ax2.set_xlabel(r'Time periods after shock',fontsize=glopt['xlabel_fs'])
            ax2.set_ylabel(r'Response'+pswitch*' in percentages',fontsize=glopt['ylabel_fs'])
            ax2.set_xlim([0,60])
            ax2.set_rasterization_zorder(1)            
            fig2.savefig('../graphs/'+modname+'/irfs/'+'sshock_'+str(shocko+1)+'/'+vnames[varo]+'_'+str(shocko+1)+'.'+graph_options['ftype'],bbox_inches='tight',dpi=graph_options['dpi'])
            plt.close(fig2)



def gen_latex_table(scalo=0.37, rowo=4, colo=3, globli=None, dest=None):
    tmpstr = ''
    tmpstr = tmpstr + r"\begin{tabular}{@{}lll}"+"\n"
    substr = ''
    colo_counto = 0
    indexor = 0
    counto = 0
    newrow = False
    while indexor < len(globli):
        counto += 1
        colo_counto += 1
        if counto != 1 and (counto-1)%(rowo*colo) == 0 and colo_counto != 1:
            tmpstr = tmpstr + "\n"+r"\end{tabular}"+"\n"+r"\newpage"+"\n"+r"\begin{tabular}{@{}lll}"+"\n"
            newrow = True
            colo_counto = 0
            counto -= 1
            indexor -= 1
        elif counto != 1 and counto%(rowo*colo) != 0 and colo_counto%colo != 0:
            substr = substr + r" & \includegraphics[scale="+str(round(scalo,2))+"]{"+"../"+globli[indexor][:-4]+"}"
            if newrow:
                substr = substr[3:]
                newrow = False
        elif counto != 1 and counto%(rowo*colo) != 0 and colo_counto%colo == 0:
            substr = substr + r" & \includegraphics[scale="+str(round(scalo,2))+"]{"+"../"+globli[indexor][:-4]+"}"+ r"\\" + "\n"
            newrow = True
            colo_counto = 0
        elif counto == 1:
            substr = substr + r"\includegraphics[scale="+str(round(scalo,2))+"]{"+"../"+globli[indexor][:-4]+"}"
        else:
            substr = substr + r" & \includegraphics[scale="+str(round(scalo,2))+"]{"+"../"+globli[indexor][:-4]+"}"
            if newrow:
                substr = substr[3:]
                newrow = False
        tmpstr = tmpstr + copy.deepcopy(substr)
        substr = ''
        indexor += 1
    tmpstr = tmpstr + "\n" + r"\end{tabular}"+"\n"
    pato = dest.split('/')
    filor = pato[-1]
    pato = [x+'/' for x in pato[:-1]]
    pato = reduce(lambda x,y:x+y, pato)
    if dest[0] == '/': pato = '/'+pato
    if filor in os.listdir(pato):
        os.remove(dest)
    f1 = open(dest,'w')
    f1.write(tmpstr)
    f1.close()

globli = glob.glob('../graphs/'+modname+'/fevds/*.'+graph_options['ftype'])
globli.sort()
gen_latex_table(globli=globli, dest='../graphs/'+modname+'/tables/fevdtable.tex')

globli = glob.glob('../graphs/'+modname+'/irfs/pshock_4/*.'+graph_options['ftype'])
globli.sort()
gen_latex_table(globli=globli, dest='../graphs/'+modname+'/tables/irftable.tex')

globli = glob.glob('../graphs/'+modname+'/factors/factor_*.'+graph_options['ftype'])
globli.sort()
globli1 = globli[1:6]
globli = [globli[0],]+globli[7:]+globli1
gen_latex_table(globli=globli[:12], dest='../graphs/'+modname+'/tables/factable.tex')

globli = glob.glob('../graphs/'+modname+'/fitted/*.'+graph_options['ftype'])
globli.sort()
gen_latex_table(globli=globli, dest='../graphs/'+modname+'/tables/fittable.tex')
